// Package common29571 provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.9.1 DO NOT EDIT.
package common29571

import (
	"bytes"
	"compress/gzip"
	"encoding/base64"
	"encoding/json"
	"fmt"
	"net/url"
	"path"
	"strings"
	"time"

	openapi_types "github.com/deepmap/oapi-codegen/pkg/types"
	"github.com/getkin/kin-openapi/openapi3"
)

// Defines values for AccessType.
const (
	AccessTypeN3GPPACCESS AccessType = "3GPP_ACCESS"

	AccessTypeNON3GPPACCESS AccessType = "NON_3GPP_ACCESS"
)

// N5GMmCause defines model for 5GMmCause.
type N5GMmCause Uinteger

// N5Qi defines model for 5Qi.
type N5Qi int

// N5QiPriorityLevel defines model for 5QiPriorityLevel.
type N5QiPriorityLevel int

// N5QiPriorityLevelRm defines model for 5QiPriorityLevelRm.
type N5QiPriorityLevelRm int

// N5QiRm defines model for 5QiRm.
type N5QiRm int

// AccessType defines model for AccessType.
type AccessType string

// AccessTypeRm defines model for AccessTypeRm.
type AccessTypeRm interface{}

// AcsInfo defines model for AcsInfo.
type AcsInfo struct {
	AcsIpv4Addr *Ipv4Addr `json:"acsIpv4Addr,omitempty"`
	AcsIpv6Addr *Ipv6Addr `json:"acsIpv6Addr,omitempty"`
	AcsUrl      *Uri      `json:"acsUrl,omitempty"`
}

// AcsInfoRm defines model for AcsInfoRm.
type AcsInfoRm interface{}

// AdditionalQosFlowInfo defines model for AdditionalQosFlowInfo.
type AdditionalQosFlowInfo interface{}

// Ambr defines model for Ambr.
type Ambr struct {
	Downlink BitRate `json:"downlink"`
	Uplink   BitRate `json:"uplink"`
}

// AmbrRm defines model for AmbrRm.
type AmbrRm interface{}

// AmfId defines model for AmfId.
type AmfId string

// AmfName defines model for AmfName.
type AmfName string

// AmfRegionId defines model for AmfRegionId.
type AmfRegionId string

// AmfSetId defines model for AmfSetId.
type AmfSetId string

// ApnRateStatus defines model for ApnRateStatus.
type ApnRateStatus struct {
	RemainExReportsDl *int      `json:"remainExReportsDl,omitempty"`
	RemainExReportsUl *int      `json:"remainExReportsUl,omitempty"`
	RemainPacketsDl   *int      `json:"remainPacketsDl,omitempty"`
	RemainPacketsUl   *int      `json:"remainPacketsUl,omitempty"`
	ValidityTime      *DateTime `json:"validityTime,omitempty"`
}

// ApplicationChargingId defines model for ApplicationChargingId.
type ApplicationChargingId string

// ApplicationId defines model for ApplicationId.
type ApplicationId string

// ApplicationIdRm defines model for ApplicationIdRm.
type ApplicationIdRm string

// Area defines model for Area.
type Area interface{}

// AreaCode defines model for AreaCode.
type AreaCode string

// AreaCodeRm defines model for AreaCodeRm.
type AreaCodeRm string

// AreaScope defines model for AreaScope.
type AreaScope struct {
	EutraCellIdList *[]EutraCellId            `json:"eutraCellIdList,omitempty"`
	NrCellIdList    *[]NrCellId               `json:"nrCellIdList,omitempty"`
	TacInfoPerPlmn  *AreaScope_TacInfoPerPlmn `json:"tacInfoPerPlmn,omitempty"`
	TacList         *[]Tac                    `json:"tacList,omitempty"`
}

// AreaScope_TacInfoPerPlmn defines model for AreaScope.TacInfoPerPlmn.
type AreaScope_TacInfoPerPlmn struct {
	AdditionalProperties map[string]TacInfo `json:"-"`
}

// ArfcnValueNR defines model for ArfcnValueNR.
type ArfcnValueNR int

// Arp defines model for Arp.
type Arp struct {
	PreemptCap  PreemptionCapability    `json:"preemptCap"`
	PreemptVuln PreemptionVulnerability `json:"preemptVuln"`

	// nullable true shall not be used for this attribute
	PriorityLevel *ArpPriorityLevel `json:"priorityLevel"`
}

// nullable true shall not be used for this attribute
type ArpPriorityLevel int

// ArpPriorityLevelRm defines model for ArpPriorityLevelRm.
type ArpPriorityLevelRm int

// ArpRm defines model for ArpRm.
type ArpRm interface{}

// Atom defines model for Atom.
type Atom struct {
	Attr     string      `json:"attr"`
	Negative *bool       `json:"negative,omitempty"`
	Value    interface{} `json:"value"`
}

// AtsssCapability defines model for AtsssCapability.
type AtsssCapability struct {
	AtsssLL       *bool `json:"atsssLL,omitempty"`
	Mptcp         *bool `json:"mptcp,omitempty"`
	RttWithoutPmf *bool `json:"rttWithoutPmf,omitempty"`
}

// Possible values are - "EAP_SUCCESS": The NSSAA status is EAP-Success. - "EAP_FAILURE": The NSSAA status is EAP-Failure. - "PENDING": The NSSAA status is Pending.
type AuthStatus interface{}

// AverWindow defines model for AverWindow.
type AverWindow int

// AverWindowRm defines model for AverWindowRm.
type AverWindowRm int

// BackupAmfInfo defines model for BackupAmfInfo.
type BackupAmfInfo struct {
	BackupAmf AmfName  `json:"backupAmf"`
	GuamiList *[]Guami `json:"guamiList,omitempty"`
}

// BatteryIndication defines model for BatteryIndication.
type BatteryIndication struct {
	BatteryInd      *bool `json:"batteryInd,omitempty"`
	RechargeableInd *bool `json:"rechargeableInd,omitempty"`
	ReplaceableInd  *bool `json:"replaceableInd,omitempty"`
}

// BatteryIndicationRm defines model for BatteryIndicationRm.
type BatteryIndicationRm interface{}

// Binary defines model for Binary.
type Binary string

// BinaryRm defines model for BinaryRm.
type BinaryRm string

// BitRate defines model for BitRate.
type BitRate string

// BitRateRm defines model for BitRateRm.
type BitRateRm string

// Bytes defines model for Bytes.
type Bytes []byte

// BytesRm defines model for BytesRm.
type BytesRm []byte

// CMsisdn defines model for CMsisdn.
type CMsisdn string

// CMsisdnRm defines model for CMsisdnRm.
type CMsisdnRm string

// CagId defines model for CagId.
type CagId string

// CellGlobalId defines model for CellGlobalId.
type CellGlobalId struct {
	CellId string `json:"cellId"`
	Lac    string `json:"lac"`
	PlmnId PlmnId `json:"plmnId"`
}

// ChangeItem defines model for ChangeItem.
type ChangeItem struct {
	From      *string      `json:"from,omitempty"`
	NewValue  *interface{} `json:"newValue,omitempty"`
	Op        ChangeType   `json:"op"`
	OrigValue *interface{} `json:"origValue,omitempty"`
	Path      string       `json:"path"`
}

// ChangeType defines model for ChangeType.
type ChangeType interface{}

// ChargingId defines model for ChargingId.
type ChargingId Uint32

// Cnf defines model for Cnf.
type Cnf struct {
	CnfUnits []CnfUnit `json:"cnfUnits"`
}

// CnfUnit defines model for CnfUnit.
type CnfUnit struct {
	CnfUnit []Atom `json:"cnfUnit"`
}

// CollectionPeriodRmmLteMdt defines model for CollectionPeriodRmmLteMdt.
type CollectionPeriodRmmLteMdt interface{}

// CollectionPeriodRmmNrMdt defines model for CollectionPeriodRmmNrMdt.
type CollectionPeriodRmmNrMdt interface{}

// ComplexQuery defines model for ComplexQuery.
type ComplexQuery interface{}

// CoreNetworkType defines model for CoreNetworkType.
type CoreNetworkType interface{}

// CoreNetworkTypeRm defines model for CoreNetworkTypeRm.
type CoreNetworkTypeRm interface{}

// Date defines model for Date.
type Date openapi_types.Date

// DateRm defines model for DateRm.
type DateRm openapi_types.Date

// DateTime defines model for DateTime.
type DateTime time.Time

// DateTimeRm defines model for DateTimeRm.
type DateTimeRm time.Time

// integer between and including 1 and 7 denoting a weekday. 1 shall indicate Monday, and the subsequent weekdays shall be indicated with the next higher numbers. 7 shall indicate Sunday.
type DayOfWeek int

// DiameterIdentity defines model for DiameterIdentity.
type DiameterIdentity string

// DiameterIdentityRm defines model for DiameterIdentityRm.
type DiameterIdentityRm string

// Possible values are - BUFFERED: The first downlink data is buffered with extended buffering matching the source of the downlink traffic. - TRANSMITTED: The first downlink data matching the source of the downlink traffic is transmitted after previous buffering or discarding of corresponding packet(s) because the UE of the PDU Session becomes ACTIVE, and buffered data can be delivered to UE. - DISCARDED: The first downlink data matching the source of the downlink traffic is discarded because the Extended Buffering time, as determined by the SMF, expires or the amount of downlink data to be buffered is exceeded.
type DlDataDeliveryStatus interface{}

// DlDataDeliveryStatusRm defines model for DlDataDeliveryStatusRm.
type DlDataDeliveryStatusRm interface{}

// Dnai defines model for Dnai.
type Dnai string

// Possible values are - EARLY: Early notification of UP path reconfiguration. - EARLY_LATE: Early and late notification of UP path reconfiguration. This value shall only be present in the subscription to the DNAI change event. - LATE: Late notification of UP path reconfiguration.
type DnaiChangeType interface{}

// DnaiChangeTypeRm defines model for DnaiChangeTypeRm.
type DnaiChangeTypeRm interface{}

// DnaiRm defines model for DnaiRm.
type DnaiRm string

// Dnf defines model for Dnf.
type Dnf struct {
	DnfUnits []DnfUnit `json:"dnfUnits"`
}

// DnfUnit defines model for DnfUnit.
type DnfUnit struct {
	DnfUnit []Atom `json:"dnfUnit"`
}

// Dnn defines model for Dnn.
type Dnn string

// DnnRm defines model for DnnRm.
type DnnRm string

// Double defines model for Double.
type Double float64

// DoubleRm defines model for DoubleRm.
type DoubleRm float64

// DurationSec defines model for DurationSec.
type DurationSec int

// DurationSecRm defines model for DurationSecRm.
type DurationSecRm int

// Dynamic5Qi defines model for Dynamic5Qi.
type Dynamic5Qi struct {
	AverWindow            *AverWindow         `json:"averWindow,omitempty"`
	CnPacketDelayBudgetDl *ExtPacketDelBudget `json:"cnPacketDelayBudgetDl,omitempty"`
	CnPacketDelayBudgetUl *ExtPacketDelBudget `json:"cnPacketDelayBudgetUl,omitempty"`
	ExtMaxDataBurstVol    *ExtMaxDataBurstVol `json:"extMaxDataBurstVol,omitempty"`
	ExtPacketDelBudget    *ExtPacketDelBudget `json:"extPacketDelBudget,omitempty"`
	MaxDataBurstVol       *MaxDataBurstVol    `json:"maxDataBurstVol,omitempty"`
	PacketDelayBudget     PacketDelBudget     `json:"packetDelayBudget"`
	PacketErrRate         PacketErrRate       `json:"packetErrRate"`
	PriorityLevel         N5QiPriorityLevel   `json:"priorityLevel"`
	ResourceType          QosResourceType     `json:"resourceType"`
}

// ENbId defines model for ENbId.
type ENbId string

// Ecgi defines model for Ecgi.
type Ecgi struct {
	EutraCellId EutraCellId `json:"eutraCellId"`
	Nid         *Nid        `json:"nid,omitempty"`
	PlmnId      PlmnId      `json:"plmnId"`
}

// EcgiRm defines model for EcgiRm.
type EcgiRm interface{}

// EutraCellId defines model for EutraCellId.
type EutraCellId string

// EutraCellIdRm defines model for EutraCellIdRm.
type EutraCellIdRm string

// EutraLocation defines model for EutraLocation.
type EutraLocation struct {
	AgeOfLocationInformation *int             `json:"ageOfLocationInformation,omitempty"`
	Ecgi                     Ecgi             `json:"ecgi"`
	GeodeticInformation      *string          `json:"geodeticInformation,omitempty"`
	GeographicalInformation  *string          `json:"geographicalInformation,omitempty"`
	GlobalENbId              *GlobalRanNodeId `json:"globalENbId,omitempty"`
	GlobalNgenbId            *GlobalRanNodeId `json:"globalNgenbId,omitempty"`
	IgnoreEcgi               *bool            `json:"ignoreEcgi,omitempty"`
	Tai                      Tai              `json:"tai"`
	UeLocationTimestamp      *DateTime        `json:"ueLocationTimestamp,omitempty"`
}

// EutraLocationRm defines model for EutraLocationRm.
type EutraLocationRm interface{}

// EventForMdt defines model for EventForMdt.
type EventForMdt interface{}

// ExtMaxDataBurstVol defines model for ExtMaxDataBurstVol.
type ExtMaxDataBurstVol int

// ExtMaxDataBurstVolRm defines model for ExtMaxDataBurstVolRm.
type ExtMaxDataBurstVolRm int

// ExtPacketDelBudget defines model for ExtPacketDelBudget.
type ExtPacketDelBudget int

// ExtPacketDelBudgetRm defines model for ExtPacketDelBudgetRm.
type ExtPacketDelBudgetRm int

// ExtSnssai defines model for ExtSnssai.
type ExtSnssai struct {
	// Embedded struct due to allOf(#/components/schemas/Snssai)
	Snssai `yaml:",inline"`
	// Embedded struct due to allOf(#/components/schemas/SnssaiExtension)
	SnssaiExtension `yaml:",inline"`
}

// ExternalGroupId defines model for ExternalGroupId.
type ExternalGroupId string

// ExternalGroupIdRm defines model for ExternalGroupIdRm.
type ExternalGroupIdRm string

// Float defines model for Float.
type Float float32

// FloatRm defines model for FloatRm.
type FloatRm float32

// GNbId defines model for GNbId.
type GNbId struct {
	BitLength int    `json:"bitLength"`
	GNBValue  string `json:"gNBValue"`
}

// Gci defines model for Gci.
type Gci string

// GeraLocation defines model for GeraLocation.
type GeraLocation interface{}

// Gli defines model for Gli.
type Gli Bytes

// GlobalRanNodeId defines model for GlobalRanNodeId.
type GlobalRanNodeId interface{}

// Gpsi defines model for Gpsi.
type Gpsi string

// GpsiRm defines model for GpsiRm.
type GpsiRm string

// GroupId defines model for GroupId.
type GroupId string

// GroupIdRm defines model for GroupIdRm.
type GroupIdRm string

// Guami defines model for Guami.
type Guami struct {
	AmfId  AmfId     `json:"amfId"`
	PlmnId PlmnIdNid `json:"plmnId"`
}

// GuamiRm defines model for GuamiRm.
type GuamiRm interface{}

// HalTemplate defines model for HalTemplate.
type HalTemplate struct {
	ContentType *string     `json:"contentType,omitempty"`
	Method      HttpMethod  `json:"method"`
	Properties  *[]Property `json:"properties,omitempty"`
	Title       *string     `json:"title,omitempty"`
}

// HfcNId defines model for HfcNId.
type HfcNId string

// HfcNIdRm defines model for HfcNIdRm.
type HfcNIdRm string

// HfcNodeId defines model for HfcNodeId.
type HfcNodeId struct {
	HfcNId HfcNId `json:"hfcNId"`
}

// HfcNodeIdRm defines model for HfcNodeIdRm.
type HfcNodeIdRm interface{}

// HttpMethod defines model for HttpMethod.
type HttpMethod interface{}

// Int32 defines model for Int32.
type Int32 int32

// Int32Rm defines model for Int32Rm.
type Int32Rm int32

// Int64 defines model for Int64.
type Int64 int64

// Int64Rm defines model for Int64Rm.
type Int64Rm int64

// InterFreqTargetInfo defines model for InterFreqTargetInfo.
type InterFreqTargetInfo struct {
	CellIdList    *[]PhysCellId `json:"cellIdList,omitempty"`
	DlCarrierFreq ArfcnValueNR  `json:"dlCarrierFreq"`
}

// InvalidParam defines model for InvalidParam.
type InvalidParam struct {
	Param  string  `json:"param"`
	Reason *string `json:"reason,omitempty"`
}

// Ipv4Addr defines model for Ipv4Addr.
type Ipv4Addr string

// Ipv4AddrMask defines model for Ipv4AddrMask.
type Ipv4AddrMask string

// Ipv4AddrMaskRm defines model for Ipv4AddrMaskRm.
type Ipv4AddrMaskRm string

// Ipv4AddrRm defines model for Ipv4AddrRm.
type Ipv4AddrRm string

// Ipv6Addr defines model for Ipv6Addr.
type Ipv6Addr struct {
	// Embedded fields due to inline allOf schema
	// Embedded fields due to inline allOf schema
}

// Ipv6AddrRm defines model for Ipv6AddrRm.
type Ipv6AddrRm struct {
	// Embedded fields due to inline allOf schema
	// Embedded fields due to inline allOf schema
}

// Ipv6Prefix defines model for Ipv6Prefix.
type Ipv6Prefix struct {
	// Embedded fields due to inline allOf schema
	// Embedded fields due to inline allOf schema
}

// Ipv6PrefixRm defines model for Ipv6PrefixRm.
type Ipv6PrefixRm struct {
	// Embedded fields due to inline allOf schema
	// Embedded fields due to inline allOf schema
}

// JobType defines model for JobType.
type JobType interface{}

// Possible values are - "LOCATION_ALLOWED_WITH_NOTIFICATION": Location allowed with notification - "LOCATION_ALLOWED_WITHOUT_NOTIFICATION": Location allowed without notification - "LOCATION_ALLOWED_WITHOUT_RESPONSE": Location with notification and privacy verification; location allowed if no response - "LOCATION_RESTRICTED_WITHOUT_RESPONSE": Location with notification and privacy verification; location restricted if no response - "NOTIFICATION_ONLY": Notification only - "NOTIFICATION_AND_VERIFICATION_ONLY": Notification and privacy verification only
type LcsServiceAuth interface{}

// Possible values are - DSL: Identifies a DSL line - PON: Identifies a PON line
type LineType interface{}

// LineTypeRm defines model for LineTypeRm.
type LineTypeRm interface{}

// Link defines model for Link.
type Link struct {
	Href *Uri `json:"href,omitempty"`
}

// LinkRm defines model for LinkRm.
type LinkRm struct {
	Href *Uri `json:"href,omitempty"`
}

// LinksValueSchema defines model for LinksValueSchema.
type LinksValueSchema interface{}

// LocationAreaId defines model for LocationAreaId.
type LocationAreaId struct {
	Lac    string `json:"lac"`
	PlmnId PlmnId `json:"plmnId"`
}

// LoggingDurationMdt defines model for LoggingDurationMdt.
type LoggingDurationMdt interface{}

// LoggingDurationNrMdt defines model for LoggingDurationNrMdt.
type LoggingDurationNrMdt interface{}

// LoggingIntervalMdt defines model for LoggingIntervalMdt.
type LoggingIntervalMdt interface{}

// LoggingIntervalNrMdt defines model for LoggingIntervalNrMdt.
type LoggingIntervalNrMdt interface{}

// LteV2xAuth defines model for LteV2xAuth.
type LteV2xAuth struct {
	PedestrianUeAuth *UeAuth `json:"pedestrianUeAuth,omitempty"`
	VehicleUeAuth    *UeAuth `json:"vehicleUeAuth,omitempty"`
}

// MacAddr48 defines model for MacAddr48.
type MacAddr48 string

// MacAddr48Rm defines model for MacAddr48Rm.
type MacAddr48Rm string

// ManAssiUeRadioCapId defines model for ManAssiUeRadioCapId.
type ManAssiUeRadioCapId Bytes

// MaxDataBurstVol defines model for MaxDataBurstVol.
type MaxDataBurstVol int

// MaxDataBurstVolRm defines model for MaxDataBurstVolRm.
type MaxDataBurstVolRm int

// MbsfnArea defines model for MbsfnArea.
type MbsfnArea struct {
	CarrierFrequency *int `json:"carrierFrequency,omitempty"`
	MbsfnAreaId      *int `json:"mbsfnAreaId,omitempty"`
}

// Mcc defines model for Mcc.
type Mcc string

// MccRm defines model for MccRm.
type MccRm string

// MdtConfiguration defines model for MdtConfiguration.
type MdtConfiguration struct {
	AddPositioningMethodList *[]PositioningMethodMdt    `json:"addPositioningMethodList,omitempty"`
	AreaScope                *AreaScope                 `json:"areaScope,omitempty"`
	CollectionPeriodRmmLte   *CollectionPeriodRmmLteMdt `json:"collectionPeriodRmmLte,omitempty"`
	CollectionPeriodRmmNr    *CollectionPeriodRmmNrMdt  `json:"collectionPeriodRmmNr,omitempty"`
	EventList                *[]EventForMdt             `json:"eventList,omitempty"`
	EventThresholdRsrp       *int                       `json:"eventThresholdRsrp,omitempty"`
	EventThresholdRsrpNr     *int                       `json:"eventThresholdRsrpNr,omitempty"`
	EventThresholdRsrq       *int                       `json:"eventThresholdRsrq,omitempty"`
	EventThresholdRsrqNr     *int                       `json:"eventThresholdRsrqNr,omitempty"`
	InterFreqTargetList      *[]InterFreqTargetInfo     `json:"interFreqTargetList,omitempty"`
	JobType                  JobType                    `json:"jobType"`
	LoggingDuration          *LoggingDurationMdt        `json:"loggingDuration,omitempty"`
	LoggingDurationNr        *LoggingDurationNrMdt      `json:"loggingDurationNr,omitempty"`
	LoggingInterval          *LoggingIntervalMdt        `json:"loggingInterval,omitempty"`
	LoggingIntervalNr        *LoggingIntervalNrMdt      `json:"loggingIntervalNr,omitempty"`
	MbsfnAreaList            *[]MbsfnArea               `json:"mbsfnAreaList,omitempty"`
	MdtAllowedPlmnIdList     *[]PlmnId                  `json:"mdtAllowedPlmnIdList,omitempty"`
	MeasurementLteList       *[]MeasurementLteForMdt    `json:"measurementLteList,omitempty"`
	MeasurementNrList        *[]MeasurementNrForMdt     `json:"measurementNrList,omitempty"`
	MeasurementPeriodLte     *MeasurementPeriodLteMdt   `json:"measurementPeriodLte,omitempty"`
	PositioningMethod        *PositioningMethodMdt      `json:"positioningMethod,omitempty"`
	ReportAmount             *ReportAmountMdt           `json:"reportAmount,omitempty"`
	ReportInterval           *ReportIntervalMdt         `json:"reportInterval,omitempty"`
	ReportIntervalNr         *ReportIntervalNrMdt       `json:"reportIntervalNr,omitempty"`
	ReportType               *ReportTypeMdt             `json:"reportType,omitempty"`
	ReportingTriggerList     *[]ReportingTrigger        `json:"reportingTriggerList,omitempty"`
	SensorMeasurementList    *[]SensorMeasurement       `json:"sensorMeasurementList,omitempty"`
}

// MeasurementLteForMdt defines model for MeasurementLteForMdt.
type MeasurementLteForMdt interface{}

// MeasurementNrForMdt defines model for MeasurementNrForMdt.
type MeasurementNrForMdt interface{}

// MeasurementPeriodLteMdt defines model for MeasurementPeriodLteMdt.
type MeasurementPeriodLteMdt interface{}

// Mnc defines model for Mnc.
type Mnc string

// MncRm defines model for MncRm.
type MncRm string

// MoExpDataCounter defines model for MoExpDataCounter.
type MoExpDataCounter struct {
	Counter   int       `json:"counter"`
	TimeStamp *DateTime `json:"timeStamp,omitempty"`
}

// MtcProviderInformation defines model for MtcProviderInformation.
type MtcProviderInformation string

// N3IwfId defines model for N3IwfId.
type N3IwfId string

// N3gaLocation defines model for N3gaLocation.
type N3gaLocation struct {
	Gci        *Gci       `json:"gci,omitempty"`
	Gli        *Gli       `json:"gli,omitempty"`
	HfcNodeId  *HfcNodeId `json:"hfcNodeId,omitempty"`
	N3IwfId    *string    `json:"n3IwfId,omitempty"`
	N3gppTai   *Tai       `json:"n3gppTai,omitempty"`
	PortNumber *Uinteger  `json:"portNumber,omitempty"`
	TnapId     *TnapId    `json:"tnapId,omitempty"`
	TwapId     *TwapId    `json:"twapId,omitempty"`
	UeIpv4Addr *Ipv4Addr  `json:"ueIpv4Addr,omitempty"`
	UeIpv6Addr *Ipv6Addr  `json:"ueIpv6Addr,omitempty"`

	// Possible values are - DSL: Identifies a DSL line - PON: Identifies a PON line
	W5gbanLineType *LineType `json:"w5gbanLineType,omitempty"`
}

// Ncgi defines model for Ncgi.
type Ncgi struct {
	Nid      *Nid     `json:"nid,omitempty"`
	NrCellId NrCellId `json:"nrCellId"`
	PlmnId   PlmnId   `json:"plmnId"`
}

// NcgiRm defines model for NcgiRm.
type NcgiRm interface{}

// NetworkId defines model for NetworkId.
type NetworkId struct {
	Mcc *Mcc `json:"mcc,omitempty"`
	Mnc *Mnc `json:"mnc,omitempty"`
}

// NfGroupId defines model for NfGroupId.
type NfGroupId string

// NfInstanceId defines model for NfInstanceId.
type NfInstanceId string

// NfServiceSetId defines model for NfServiceSetId.
type NfServiceSetId string

// NfSetId defines model for NfSetId.
type NfSetId string

// NgApCause defines model for NgApCause.
type NgApCause struct {
	Group Uinteger `json:"group"`
	Value Uinteger `json:"value"`
}

// NgeNbId defines model for NgeNbId.
type NgeNbId string

// Nid defines model for Nid.
type Nid string

// NidRm defines model for NidRm.
type NidRm string

// NonDynamic5Qi defines model for NonDynamic5Qi.
type NonDynamic5Qi struct {
	AverWindow            *AverWindow         `json:"averWindow,omitempty"`
	CnPacketDelayBudgetDl *ExtPacketDelBudget `json:"cnPacketDelayBudgetDl,omitempty"`
	CnPacketDelayBudgetUl *ExtPacketDelBudget `json:"cnPacketDelayBudgetUl,omitempty"`
	ExtMaxDataBurstVol    *ExtMaxDataBurstVol `json:"extMaxDataBurstVol,omitempty"`
	MaxDataBurstVol       *MaxDataBurstVol    `json:"maxDataBurstVol,omitempty"`
	PriorityLevel         *N5QiPriorityLevel  `json:"priorityLevel,omitempty"`
}

// NotificationControl defines model for NotificationControl.
type NotificationControl interface{}

// NotificationControlRm defines model for NotificationControlRm.
type NotificationControlRm interface{}

// NotifyItem defines model for NotifyItem.
type NotifyItem struct {
	Changes    []ChangeItem `json:"changes"`
	ResourceId Uri          `json:"resourceId"`
}

// NrCellId defines model for NrCellId.
type NrCellId string

// NrCellIdRm defines model for NrCellIdRm.
type NrCellIdRm string

// NrLocation defines model for NrLocation.
type NrLocation struct {
	AgeOfLocationInformation *int             `json:"ageOfLocationInformation,omitempty"`
	GeodeticInformation      *string          `json:"geodeticInformation,omitempty"`
	GeographicalInformation  *string          `json:"geographicalInformation,omitempty"`
	GlobalGnbId              *GlobalRanNodeId `json:"globalGnbId,omitempty"`
	Ncgi                     Ncgi             `json:"ncgi"`
	Tai                      Tai              `json:"tai"`
	UeLocationTimestamp      *DateTime        `json:"ueLocationTimestamp,omitempty"`
}

// NrLocationRm defines model for NrLocationRm.
type NrLocationRm interface{}

// NrV2xAuth defines model for NrV2xAuth.
type NrV2xAuth struct {
	PedestrianUeAuth *UeAuth `json:"pedestrianUeAuth,omitempty"`
	VehicleUeAuth    *UeAuth `json:"vehicleUeAuth,omitempty"`
}

// NssaaStatus defines model for NssaaStatus.
type NssaaStatus struct {
	Snssai Snssai `json:"snssai"`

	// Possible values are - "EAP_SUCCESS": The NSSAA status is EAP-Success. - "EAP_FAILURE": The NSSAA status is EAP-Failure. - "PENDING": The NSSAA status is Pending.
	Status AuthStatus `json:"status"`
}

// NssaaStatusRm defines model for NssaaStatusRm.
type NssaaStatusRm interface{}

// NullValue defines model for NullValue.
type NullValue interface{}

// OdbData defines model for OdbData.
type OdbData struct {
	RoamingOdb *RoamingOdb `json:"roamingOdb,omitempty"`
}

// OdbPacketServices defines model for OdbPacketServices.
type OdbPacketServices interface{}

// PacketDelBudget defines model for PacketDelBudget.
type PacketDelBudget int

// PacketDelBudgetRm defines model for PacketDelBudgetRm.
type PacketDelBudgetRm int

// PacketErrRate defines model for PacketErrRate.
type PacketErrRate string

// PacketErrRateRm defines model for PacketErrRateRm.
type PacketErrRateRm string

// PacketLossRate defines model for PacketLossRate.
type PacketLossRate int

// PacketLossRateRm defines model for PacketLossRateRm.
type PacketLossRateRm int

// PatchItem defines model for PatchItem.
type PatchItem struct {
	From  *string        `json:"from,omitempty"`
	Op    PatchOperation `json:"op"`
	Path  string         `json:"path"`
	Value *interface{}   `json:"value,omitempty"`
}

// PatchOperation defines model for PatchOperation.
type PatchOperation interface{}

// PatchResult defines model for PatchResult.
type PatchResult struct {
	Report []ReportItem `json:"report"`
}

// Pc5FlowBitRates defines model for Pc5FlowBitRates.
type Pc5FlowBitRates struct {
	GuaFbr *BitRate `json:"guaFbr,omitempty"`
	MaxFbr *BitRate `json:"maxFbr,omitempty"`
}

// Pc5QoSPara defines model for Pc5QoSPara.
type Pc5QoSPara struct {
	Pc5LinkAmbr    *BitRate         `json:"pc5LinkAmbr,omitempty"`
	Pc5QosFlowList []Pc5QosFlowItem `json:"pc5QosFlowList"`
}

// Pc5QosFlowItem defines model for Pc5QosFlowItem.
type Pc5QosFlowItem struct {
	Pc5FlowBitRates *Pc5FlowBitRates `json:"pc5FlowBitRates,omitempty"`
	Pqi             N5Qi             `json:"pqi"`
	Range           *Uinteger        `json:"range,omitempty"`
}

// PduSessionId defines model for PduSessionId.
type PduSessionId int

// PduSessionType defines model for PduSessionType.
type PduSessionType interface{}

// PduSessionTypeRm defines model for PduSessionTypeRm.
type PduSessionTypeRm interface{}

// Pei defines model for Pei.
type Pei string

// PeiRm defines model for PeiRm.
type PeiRm string

// PhysCellId defines model for PhysCellId.
type PhysCellId int

// PlmnAssiUeRadioCapId defines model for PlmnAssiUeRadioCapId.
type PlmnAssiUeRadioCapId Bytes

// PlmnId defines model for PlmnId.
type PlmnId struct {
	Mcc Mcc `json:"mcc"`
	Mnc Mnc `json:"mnc"`
}

// PlmnIdNid defines model for PlmnIdNid.
type PlmnIdNid struct {
	Mcc Mcc  `json:"mcc"`
	Mnc Mnc  `json:"mnc"`
	Nid *Nid `json:"nid,omitempty"`
}

// PlmnIdRm defines model for PlmnIdRm.
type PlmnIdRm interface{}

// PositioningMethodMdt defines model for PositioningMethodMdt.
type PositioningMethodMdt interface{}

// PreemptionCapability defines model for PreemptionCapability.
type PreemptionCapability interface{}

// PreemptionCapabilityRm defines model for PreemptionCapabilityRm.
type PreemptionCapabilityRm interface{}

// PreemptionVulnerability defines model for PreemptionVulnerability.
type PreemptionVulnerability interface{}

// PreemptionVulnerabilityRm defines model for PreemptionVulnerabilityRm.
type PreemptionVulnerabilityRm interface{}

// PresenceInfo defines model for PresenceInfo.
type PresenceInfo struct {
	AdditionalPraId     *string            `json:"additionalPraId,omitempty"`
	EcgiList            *[]Ecgi            `json:"ecgiList,omitempty"`
	GlobalRanNodeIdList *[]GlobalRanNodeId `json:"globalRanNodeIdList,omitempty"`
	GlobaleNbIdList     *[]GlobalRanNodeId `json:"globaleNbIdList,omitempty"`
	NcgiList            *[]Ncgi            `json:"ncgiList,omitempty"`
	PraId               *string            `json:"praId,omitempty"`
	PresenceState       *PresenceState     `json:"presenceState,omitempty"`
	TrackingAreaList    *[]Tai             `json:"trackingAreaList,omitempty"`
}

// PresenceInfoRm defines model for PresenceInfoRm.
type PresenceInfoRm struct {
	AdditionalPraId     *string            `json:"additionalPraId,omitempty"`
	EcgiList            *[]Ecgi            `json:"ecgiList,omitempty"`
	GlobalRanNodeIdList *[]GlobalRanNodeId `json:"globalRanNodeIdList,omitempty"`
	GlobaleNbIdList     *[]GlobalRanNodeId `json:"globaleNbIdList,omitempty"`
	NcgiList            *[]Ncgi            `json:"ncgiList,omitempty"`
	PraId               *string            `json:"praId,omitempty"`
	PresenceState       *PresenceState     `json:"presenceState,omitempty"`
	TrackingAreaList    *[]Tai             `json:"trackingAreaList,omitempty"`
}

// PresenceState defines model for PresenceState.
type PresenceState interface{}

// ProblemDetails defines model for ProblemDetails.
type ProblemDetails struct {
	Cause             *string            `json:"cause,omitempty"`
	Detail            *string            `json:"detail,omitempty"`
	Instance          *Uri               `json:"instance,omitempty"`
	InvalidParams     *[]InvalidParam    `json:"invalidParams,omitempty"`
	NrfId             *string            `json:"nrfId,omitempty"`
	Status            *int               `json:"status,omitempty"`
	SupportedFeatures *SupportedFeatures `json:"supportedFeatures,omitempty"`
	TargetScp         *Uri               `json:"targetScp,omitempty"`
	Title             *string            `json:"title,omitempty"`
	Type              *Uri               `json:"type,omitempty"`
}

// Property defines model for Property.
type Property struct {
	Name     string  `json:"name"`
	Regex    *string `json:"regex,omitempty"`
	Required *bool   `json:"required,omitempty"`
	Value    *string `json:"value,omitempty"`
}

// Qfi defines model for Qfi.
type Qfi int

// QfiRm defines model for QfiRm.
type QfiRm int

// QosFlowUsageReport defines model for QosFlowUsageReport.
type QosFlowUsageReport struct {
	DownlinkVolume Int64    `json:"downlinkVolume"`
	EndTimeStamp   DateTime `json:"endTimeStamp"`
	Qfi            Qfi      `json:"qfi"`
	StartTimeStamp DateTime `json:"startTimeStamp"`
	UplinkVolume   Int64    `json:"uplinkVolume"`
}

// QosResourceType defines model for QosResourceType.
type QosResourceType interface{}

// QosResourceTypeRm defines model for QosResourceTypeRm.
type QosResourceTypeRm interface{}

// RatType defines model for RatType.
type RatType interface{}

// RatTypeRm defines model for RatTypeRm.
type RatTypeRm interface{}

// RatingGroup defines model for RatingGroup.
type RatingGroup Uint32

// RefToBinaryData defines model for RefToBinaryData.
type RefToBinaryData struct {
	ContentId string `json:"contentId"`
}

// RefToBinaryDataRm defines model for RefToBinaryDataRm.
type RefToBinaryDataRm interface{}

// ReflectiveQoSAttribute defines model for ReflectiveQoSAttribute.
type ReflectiveQoSAttribute interface{}

// ReflectiveQoSAttributeRm defines model for ReflectiveQoSAttributeRm.
type ReflectiveQoSAttributeRm interface{}

// ReportAmountMdt defines model for ReportAmountMdt.
type ReportAmountMdt interface{}

// ReportIntervalMdt defines model for ReportIntervalMdt.
type ReportIntervalMdt interface{}

// ReportIntervalNrMdt defines model for ReportIntervalNrMdt.
type ReportIntervalNrMdt interface{}

// ReportItem defines model for ReportItem.
type ReportItem struct {
	Path string `json:"path"`
}

// ReportTypeMdt defines model for ReportTypeMdt.
type ReportTypeMdt interface{}

// ReportingTrigger defines model for ReportingTrigger.
type ReportingTrigger interface{}

// RestrictionType defines model for RestrictionType.
type RestrictionType interface{}

// RestrictionTypeRm defines model for RestrictionTypeRm.
type RestrictionTypeRm interface{}

// RfspIndex defines model for RfspIndex.
type RfspIndex int

// RfspIndexRm defines model for RfspIndexRm.
type RfspIndexRm int

// RgWirelineCharacteristics defines model for RgWirelineCharacteristics.
type RgWirelineCharacteristics Bytes

// RgWirelineCharacteristicsRm defines model for RgWirelineCharacteristicsRm.
type RgWirelineCharacteristicsRm interface{}

// RoamingOdb defines model for RoamingOdb.
type RoamingOdb interface{}

// RouteInformation defines model for RouteInformation.
type RouteInformation struct {
	Ipv4Addr   *Ipv4Addr `json:"ipv4Addr,omitempty"`
	Ipv6Addr   *Ipv6Addr `json:"ipv6Addr,omitempty"`
	PortNumber Uinteger  `json:"portNumber"`
}

// RouteToLocation defines model for RouteToLocation.
type RouteToLocation interface{}

// RoutingAreaId defines model for RoutingAreaId.
type RoutingAreaId struct {
	Lac    string `json:"lac"`
	PlmnId PlmnId `json:"plmnId"`
	Rac    string `json:"rac"`
}

// SamplingRatio defines model for SamplingRatio.
type SamplingRatio int

// SamplingRatioRm defines model for SamplingRatioRm.
type SamplingRatioRm int

// ScheduledCommunicationTime defines model for ScheduledCommunicationTime.
type ScheduledCommunicationTime struct {
	// Identifies the day(s) of the week. If absent, it indicates every day of the week.
	DaysOfWeek *[]DayOfWeek `json:"daysOfWeek,omitempty"`

	// String with format partial-time or full-time as defined in clause 5.6 of IETF RFC 3339. Examples, 20:15:00, 20:15:00-08:00 (for 8 hours behind UTC).
	TimeOfDayEnd *TimeOfDay `json:"timeOfDayEnd,omitempty"`

	// String with format partial-time or full-time as defined in clause 5.6 of IETF RFC 3339. Examples, 20:15:00, 20:15:00-08:00 (for 8 hours behind UTC).
	TimeOfDayStart *TimeOfDay `json:"timeOfDayStart,omitempty"`
}

// ScheduledCommunicationTimeRm defines model for ScheduledCommunicationTimeRm.
type ScheduledCommunicationTimeRm interface{}

// ScheduledCommunicationType defines model for ScheduledCommunicationType.
type ScheduledCommunicationType interface{}

// ScheduledCommunicationTypeRm defines model for ScheduledCommunicationTypeRm.
type ScheduledCommunicationTypeRm interface{}

// A range of SDs (Slice Differentiators)
type SdRange struct {
	End   *string `json:"end,omitempty"`
	Start *string `json:"start,omitempty"`
}

// SecondaryRatUsageInfo defines model for SecondaryRatUsageInfo.
type SecondaryRatUsageInfo struct {
	PduSessionUsageData *[]VolumeTimedReport  `json:"pduSessionUsageData,omitempty"`
	QosFlowsUsageData   *[]QosFlowUsageReport `json:"qosFlowsUsageData,omitempty"`
	SecondaryRatType    RatType               `json:"secondaryRatType"`
}

// SecondaryRatUsageReport defines model for SecondaryRatUsageReport.
type SecondaryRatUsageReport struct {
	QosFlowsUsageData []QosFlowUsageReport `json:"qosFlowsUsageData"`
	SecondaryRatType  RatType              `json:"secondaryRatType"`
}

// SelfLink defines model for SelfLink.
type SelfLink struct {
	Self Link `json:"self"`
}

// SensorMeasurement defines model for SensorMeasurement.
type SensorMeasurement interface{}

// ServiceAreaId defines model for ServiceAreaId.
type ServiceAreaId struct {
	Lac    string `json:"lac"`
	PlmnId PlmnId `json:"plmnId"`
	Sac    string `json:"sac"`
}

// ServiceAreaRestriction defines model for ServiceAreaRestriction.
type ServiceAreaRestriction struct {
	// Embedded fields due to inline allOf schema
	// Embedded fields due to inline allOf schema
	// Embedded fields due to inline allOf schema
}

// ServiceId defines model for ServiceId.
type ServiceId Uint32

// SmallDataRateStatus defines model for SmallDataRateStatus.
type SmallDataRateStatus struct {
	RemainExReportsDl *int      `json:"remainExReportsDl,omitempty"`
	RemainExReportsUl *int      `json:"remainExReportsUl,omitempty"`
	RemainPacketsDl   *int      `json:"remainPacketsDl,omitempty"`
	RemainPacketsUl   *int      `json:"remainPacketsUl,omitempty"`
	ValidityTime      *DateTime `json:"validityTime,omitempty"`
}

// Snssai defines model for Snssai.
type Snssai struct {
	Sd  *string `json:"sd,omitempty"`
	Sst int     `json:"sst"`
}

// Extensions to the Snssai data type
type SnssaiExtension struct {
	SdRanges   *[]SdRange `json:"sdRanges,omitempty"`
	WildcardSd *bool      `json:"wildcardSd,omitempty"`
}

// SscMode defines model for SscMode.
type SscMode interface{}

// SscModeRm defines model for SscModeRm.
type SscModeRm interface{}

// Possible values are - STATIONARY: Identifies the UE is stationary - MOBILE: Identifies the UE is mobile
type StationaryIndication interface{}

// StationaryIndicationRm defines model for StationaryIndicationRm.
type StationaryIndicationRm interface{}

// StnSr defines model for StnSr.
type StnSr string

// StnSrRm defines model for StnSrRm.
type StnSrRm string

// SubscribedDefaultQos defines model for SubscribedDefaultQos.
type SubscribedDefaultQos struct {
	N5qi          N5Qi               `json:"5qi"`
	Arp           Arp                `json:"arp"`
	PriorityLevel *N5QiPriorityLevel `json:"priorityLevel,omitempty"`
}

// Supi defines model for Supi.
type Supi string

// SupiOrSuci defines model for SupiOrSuci.
type SupiOrSuci string

// SupiRm defines model for SupiRm.
type SupiRm string

// SupportedFeatures defines model for SupportedFeatures.
type SupportedFeatures string

// Tac defines model for Tac.
type Tac string

// TacInfo defines model for TacInfo.
type TacInfo struct {
	TacList []Tac `json:"tacList"`
}

// TacRm defines model for TacRm.
type TacRm string

// Tai defines model for Tai.
type Tai struct {
	Nid    *Nid   `json:"nid,omitempty"`
	PlmnId PlmnId `json:"plmnId"`
	Tac    Tac    `json:"tac"`
}

// TaiRm defines model for TaiRm.
type TaiRm interface{}

// String with format partial-time or full-time as defined in clause 5.6 of IETF RFC 3339. Examples, 20:15:00, 20:15:00-08:00 (for 8 hours behind UTC).
type TimeOfDay string

// TimeZone defines model for TimeZone.
type TimeZone string

// TimeZoneRm defines model for TimeZoneRm.
type TimeZoneRm string

// TnapId defines model for TnapId.
type TnapId struct {
	BssId        *string `json:"bssId,omitempty"`
	CivicAddress *Bytes  `json:"civicAddress,omitempty"`
	SsId         *string `json:"ssId,omitempty"`
}

// TnapIdRm defines model for TnapIdRm.
type TnapIdRm interface{}

// TngfId defines model for TngfId.
type TngfId string

// TraceData defines model for TraceData.
type TraceData struct {
	CollectionEntityIpv4Addr *Ipv4Addr  `json:"collectionEntityIpv4Addr,omitempty"`
	CollectionEntityIpv6Addr *Ipv6Addr  `json:"collectionEntityIpv6Addr,omitempty"`
	EventList                string     `json:"eventList"`
	InterfaceList            *string    `json:"interfaceList,omitempty"`
	NeTypeList               string     `json:"neTypeList"`
	TraceDepth               TraceDepth `json:"traceDepth"`
	TraceRef                 string     `json:"traceRef"`
}

// TraceDepth defines model for TraceDepth.
type TraceDepth interface{}

// TraceDepthRm defines model for TraceDepthRm.
type TraceDepthRm interface{}

// Possible values are - SINGLE_TRANS_UL: Uplink single packet transmission. - SINGLE_TRANS_DL: Downlink single packet transmission. - DUAL_TRANS_UL_FIRST: Dual packet transmission, firstly uplink packet transmission with subsequent downlink packet transmission. - DUAL_TRANS_DL_FIRST: Dual packet transmission, firstly downlink packet transmission with subsequent uplink packet transmission.
type TrafficProfile interface{}

// TrafficProfileRm defines model for TrafficProfileRm.
type TrafficProfileRm interface{}

// TwapId defines model for TwapId.
type TwapId struct {
	BssId        *string `json:"bssId,omitempty"`
	CivicAddress *Bytes  `json:"civicAddress,omitempty"`
	SsId         string  `json:"ssId"`
}

// TwapIdRm defines model for TwapIdRm.
type TwapIdRm interface{}

// TypeAllocationCode defines model for TypeAllocationCode.
type TypeAllocationCode string

// UeAuth defines model for UeAuth.
type UeAuth interface{}

// Uint16 defines model for Uint16.
type Uint16 int

// Uint16Rm defines model for Uint16Rm.
type Uint16Rm int

// Uint32 defines model for Uint32.
type Uint32 int

// Uint32Rm defines model for Uint32Rm.
type Uint32Rm int32

// Uint64 defines model for Uint64.
type Uint64 int

// Uint64Rm defines model for Uint64Rm.
type Uint64Rm int

// Uinteger defines model for Uinteger.
type Uinteger int

// UintegerRm defines model for UintegerRm.
type UintegerRm int

// UpConfidentiality defines model for UpConfidentiality.
type UpConfidentiality interface{}

// UpConfidentialityRm defines model for UpConfidentialityRm.
type UpConfidentialityRm interface{}

// UpIntegrity defines model for UpIntegrity.
type UpIntegrity interface{}

// UpIntegrityRm defines model for UpIntegrityRm.
type UpIntegrityRm interface{}

// UpSecurity defines model for UpSecurity.
type UpSecurity struct {
	UpConfid UpConfidentiality `json:"upConfid"`
	UpIntegr UpIntegrity       `json:"upIntegr"`
}

// UpSecurityRm defines model for UpSecurityRm.
type UpSecurityRm interface{}

// Uri defines model for Uri.
type Uri string

// UriRm defines model for UriRm.
type UriRm string

// UriScheme defines model for UriScheme.
type UriScheme interface{}

// UserLocation defines model for UserLocation.
type UserLocation struct {
	EutraLocation *EutraLocation `json:"eutraLocation,omitempty"`
	N3gaLocation  *N3gaLocation  `json:"n3gaLocation,omitempty"`
	NrLocation    *NrLocation    `json:"nrLocation,omitempty"`
}

// UtraLocation defines model for UtraLocation.
type UtraLocation interface{}

// VarUeId defines model for VarUeId.
type VarUeId string

// VarUeIdRm defines model for VarUeIdRm.
type VarUeIdRm string

// VolumeTimedReport defines model for VolumeTimedReport.
type VolumeTimedReport struct {
	DownlinkVolume Int64    `json:"downlinkVolume"`
	EndTimeStamp   DateTime `json:"endTimeStamp"`
	StartTimeStamp DateTime `json:"startTimeStamp"`
	UplinkVolume   Int64    `json:"uplinkVolume"`
}

// WAgfId defines model for WAgfId.
type WAgfId string

// WildcardDnn defines model for WildcardDnn.
type WildcardDnn string

// WildcardDnnRm defines model for WildcardDnnRm.
type WildcardDnnRm string

// WirelineArea defines model for WirelineArea.
type WirelineArea struct {
	AreaCodeB     *AreaCode `json:"areaCodeB,omitempty"`
	AreaCodeC     *AreaCode `json:"areaCodeC,omitempty"`
	GlobalLineIds *[]Gli    `json:"globalLineIds,omitempty"`
	HfcNIds       *[]HfcNId `json:"hfcNIds,omitempty"`
}

// WirelineServiceAreaRestriction defines model for WirelineServiceAreaRestriction.
type WirelineServiceAreaRestriction struct {
	Areas           *[]WirelineArea  `json:"areas,omitempty"`
	RestrictionType *RestrictionType `json:"restrictionType,omitempty"`
}

// Getter for additional properties for AreaScope_TacInfoPerPlmn. Returns the specified
// element and whether it was found
func (a AreaScope_TacInfoPerPlmn) Get(fieldName string) (value TacInfo, found bool) {
	if a.AdditionalProperties != nil {
		value, found = a.AdditionalProperties[fieldName]
	}
	return
}

// Setter for additional properties for AreaScope_TacInfoPerPlmn
func (a *AreaScope_TacInfoPerPlmn) Set(fieldName string, value TacInfo) {
	if a.AdditionalProperties == nil {
		a.AdditionalProperties = make(map[string]TacInfo)
	}
	a.AdditionalProperties[fieldName] = value
}

// Override default JSON handling for AreaScope_TacInfoPerPlmn to handle AdditionalProperties
func (a *AreaScope_TacInfoPerPlmn) UnmarshalJSON(b []byte) error {
	object := make(map[string]json.RawMessage)
	err := json.Unmarshal(b, &object)
	if err != nil {
		return err
	}

	if len(object) != 0 {
		a.AdditionalProperties = make(map[string]TacInfo)
		for fieldName, fieldBuf := range object {
			var fieldVal TacInfo
			err := json.Unmarshal(fieldBuf, &fieldVal)
			if err != nil {
				return fmt.Errorf("error unmarshaling field %s: %w", fieldName, err)
			}
			a.AdditionalProperties[fieldName] = fieldVal
		}
	}
	return nil
}

// Override default JSON handling for AreaScope_TacInfoPerPlmn to handle AdditionalProperties
func (a AreaScope_TacInfoPerPlmn) MarshalJSON() ([]byte, error) {
	var err error
	object := make(map[string]json.RawMessage)

	for fieldName, field := range a.AdditionalProperties {
		object[fieldName], err = json.Marshal(field)
		if err != nil {
			return nil, fmt.Errorf("error marshaling '%s': %w", fieldName, err)
		}
	}
	return json.Marshal(object)
}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+x923rbONLgq/Dj9oU9oR1JPkZ7MSNLtKNtiVIoKZmexKMPIiEZE54aBG1rEj3QvsY+",
	"2X4ASIkHUCQUd7vn78lFLJKoAwqnQqGq8E21fDfwPeiRUG1/UzEMA98LIXs4bzToH8v3CPQI/QmCwEEW",
	"IMj33gbYXzjQffOv0Pfot9B6gC6gv37CcKm21f/1dof7Lf8avh1zqB4kADmhutlsNNWGoYVRQLGqbfUG",
	"2AqGv0YwJOpGU88bzVdgYuaBiDz4GP0b2pyLs1fg4tbHC2Tb0OMsnL8CC4ZPlFs/8mIpXFCM2RJDSB58",
	"W6EFO47jPyUCuywWPW9c8nKWBQMCFg7kRa9foWIm72LKFLnQj+Ku9u4VGOn63tJBFueg+Roj7s73eEM0",
	"X2OoDaC3Ig8KbQ+E487TbL0CI2MMLd+zEX1UbgFyEmZeY+iPwdrxga1MfV8ZALyKG+g1poCZ2eds+N6K",
	"c3HxKjNyGAWBjwm0lSG0EVCm64BLpfUaw5ZKZAi8tRJPJCFl5eJVVsy+RyD2gKNMIH6EWNEx9jFnp/lK",
	"S0bfDRzoQo/wMXTxKssnFQeyoDLzwCNATrLeXLzKQnoHCHwC6/R6Y8MliBxSXCfvoAcxspKG3GgxF0wr",
	"u7gbul0QhbCKpxnyCFxB3hM+IFrcBc/IjVy13bq40FQXefypoamEDqa2mgUZY+RjRNYD+AidDHyzdZWC",
	"b9aBN939GLzI4U3UJjiCJRhzSArVqEZCdY8wZHNH+5sKPQr4WT27G4/nnW5Xn0xUTTVGxjz95n6LKCQY",
	"8Vlwh4fzBLz1aKm2P+9vkxT1jba/qBE5zkfgRFDd3DN6Yd9b+pRUgP0AYoK4lg6ssB88nndsG1f1iG25",
	"jRaDXdYEu0yBzbBT2fUwYt02lpq/+BfkCk5cCzmR8YrLysvmKzlwPvjhreM/JdLbUd39SrrBcGTq80H/",
	"Z33wi6jRv+Xf3Msy5S5wsQVt/8lzkPe1Sqo3iJiAsDksCqQANpqKE/2q/TmB1naU70Vt5S6wVEPRykkL",
	"ZNm3mUQAoYuY2lb/+blzcgtOlo2Td/ffLjc/qaLB5y4N4LIRLPpmwhXyvb2IW6WIJ5AUIRsnZ/d1wAOP",
	"CnxCAInCYkNj6ALk6c8mpIpM2ONz6t5ZOAcyqw0yBtZXKEMjBqhD4RE4yEZkTdeyqj7YAwSycuL5YLfy",
	"dh8AXiFvxYUvEO22ZJ0SvOOWLAcpGAzZ2u57MO7h6XFCgBWqbIyn3wIMQde3oXq/udfyk3HyrUIqnaQc",
	"FQql0v6mIgLdsApwCiwK4yKvz4vv1l6AMViXiDnFllAG9KOEyCaWz9fPbO1hRDDoQsfp2wMUktqV0ndw",
	"FZXTVA8fQMDANbETYNF1Ygzx2HGZ/ge268g4U9eKRoqXrGJTEGBJsX5ogy8tj82zhpnRmM5aV++al5XK",
	"XwcHxeYNMIRuQLogqFaHWUk6qkEAFshBhIk3xvAxcrz6KGhpiDNYcmrp/pEWZNXY/GKYxaala5llWLhG",
	"5rEXdPlkPCl0OCnhA3AcxfOJsoBKFEJbWfpYIQ8oVAAhGC0iAlUtpSVfyCrJeY7yavchCKW0ABxIKwHE",
	"dwV6LSFYOF95cAUIekxPZgvfdyDw4rUpop/yzczQJZ+FTUnCMEx1VwFDYRgOBryJ453bEjjhTmopNtyA",
	"WEG9opiQT4g8+BEZu8s6IMIBH5GHndpR1Gz1zng+mSUbHPp02+kPZqauaupYN3p9406s8easHrSn8q9K",
	"gP1HZMOQduEngO0T2tKAIC4/5QmRB2UZkQhDBT4T6IXI90KF+Ap5gArlC2K2WCuLiCgoZKOCDQniK9Cz",
	"fBsq8R5dseESedBWkMeAAwxD+voRYopU8Zd8CHXG/dMvXlExuy9Y1/wwRHRQsu4QKgBD5UT5kpbSF7Wt",
	"TB+gYkwmnY4SMtFSLvXO+GQSsW3c6RYmluU+mFuAnAhDDhNLvKz8GHo28la0LrRpHyH+hDzbf8p0jlaj",
	"0UjNFOeNdxdVW/IdJj6i6+OqniZugPU1Cqg+L9ylLpLPlfN1rNpvNHUVARdJLZZ3FKJ6uUzPCzvGRJPC",
	"DdsDrPueHWuWopolRcQTEoYW1WwhFd+eQoEDrH1lNnW4k5moi1WTnLZvkAcwmyeXPnYBodzyVwKtkRfm",
	"/BWLVyqdyU42uy378sV+c/Tlyyn9e/xX5WgRhN9/pv8N6X939L/pIgiPf1LLUYq13hcjsia8l+zqvGYr",
	"vLhkXj68bKV0usMQhbZX3LS+u/92oTUvxJvVGKpSAJV4wGrvVvu6BAw6zp3jL4ATQ2dGlcX19VKsQpQO",
	"sIQaQ+C48aZxr8bJSxX0Q/6aY9cSxkSTRfcBeCtI551ifZaY6zgCbebpY6KyaKpfqVpzIsnZh4/RKgUe",
	"APIgoJKrkc80W1q0vBaJgbSoSXR6PVVTh6OPVHUw9e2P8aDT1etazdTsbr/KjH3WYpx5S0FH8ZYzD5H6",
	"O+guB5BbJbZUhBKLMZbxVps1pggfwpeYLd9xoEVn9jHEyLdN1x0QOLSJsF2bjda51mxdN7RW4/xaa11c",
	"NrSLZquh0Q8N7bLRaDRqN26RsoH3EmY0DyfnBg58/hBBvhztjDkV/aByxevRMpwEhgYkTz7+Wj4yLu66",
	"VLced+uPgixameU7z5Hk4t2LV9PtWmMD8brU266R+aKVy9LW9JcHPiH07R4IAcEEpgbV9Wj5CcKvxb14",
	"rK4qC0ieIPQU4NEtheVEVNtWmuz5SrGh5xP6AihPEH61wfpUacY7d8S1JagMfc8Ga42B0C1JGC1C+GtE",
	"dyUxUBiDLOAWyuabIlreg89EeUCrB4gVL3IXEIenylWeyiSiVE7TFoHKc7ceAi4kEPdt6JFkI7tbQ48+",
	"d07+AU7+TRfRN0efT1JPx1++nB6/+QxO/n3/raWJV+089krt4UfpOT1AQA866BHi9b4d7s3s9lY3dbo4",
	"Tc2OMRn2p1P21OtPuh2zp/f+9BvcRER817lEOCRKcgSk2IAAyuUiWi4hTvoqq5gN7fg1FYsLiPVAf7B+",
	"70fYgpxBuENGMFgukUV3u6nGKKcrgZPySDDwQhcROqTAkkBMJfaI/ChM8eljxUahBTAb3f5SsXzM/RvZ",
	"i4CddxyFx8oCWiAKIaM20xO6495MmcCQyX8BLd+FodLpTvsfdT7qt3JiFbAALaXYvKPyNp7ptP7b7vdi",
	"tY9rRRslxbmetNTNVgJ0ytQUECo2HbIu62GLNSs9Gd5qCnwOEIahwkyQUAGuH3mEUs6yR3xatW19UajA",
	"ZwtCG9qxhUI0SGXWMuEgl13QPICECjb9UKXT6h1z8Auzi5mDX+aDzpSqtOzPn33KYBJpKzrAzppyg5ax",
	"tYASmI0Vuo1QmOPcEq0izvxpAsckmQDTMePQRa02FiZYxk28Lvqes6ZdMalrXHW69iYVSWTZMzp9xWLN",
	"rsBH6BHKFGdnIMNE3MEzfUiqa2d73wGduuaxXE+0ObJlN0e9QzZH9r7NUa9sc2T/5psje8/mqOd5JbOF",
	"V1fgfsQ+p/VU/mpbmCt2u8J5tTYpXkIrBR53xwlMGzjSSt+uwF720yBrD7jIij3DckcdGZPz3lbZldxo",
	"qhV7EfSgA9Y3kb2CpFd5Qqc/ky0UhylBNTsQFXwmQ/BMl5ibCIfko18HTx6C48ljP4gfV44ZASdBXjSV",
	"tq0iFxyHjnFiWK2GTwrLnsEWXAnZQOWKTrIo74P/4Idmunh+oGdwacUT3YK08rUXzRC6sSgYII+GwMI+",
	"NG5O0gbOi833gfDD5eb7pAzive/C/OurjdiKrFsrtNfbQtLBwkOVEAayX85ymuZUKGprhWQWVSYPyaVU",
	"z0qrxFZ9Jd6FpoCrzeU10Q38shMlsIKjZfK57/H1Ii6ZduS4vKpy44Bxx6khTHUFfRsSZOUI5g4COie3",
	"999aDXG9VtBfYRA8IAs4NdA0S7z7VuxUYDv+9h74saIm8Azfhrxzc2hjBb3D4NHK8zFMhlz18T0BqNqH",
	"h0k4gkmjTpELQwLcQMp7LuuahtS4fYUjKt3DpIZWpmvKjjGqaN/6paZedTSbzke38+7oo2527lRN7bTm",
	"+kfdmNa2mOrCtXznEN5g/1Lj4rzx7lI0NIqI8r7lJaiqNStdqCfst9oVYWJ2pA7h9Wcy8cKQ90jgODUa",
	"PC5f1dK8mJ7sWbeNwQJP7rAfBYV5FT6TFf2A7JPP//zb/Zu/sf/FE2IWUeUcK4H61vEByajdS/ZGoGWz",
	"ojkdPSlcqaLfbdWFrHcAIjzALTd5p7pVqyVqypVxkxzslTpHa8Kj1byDw5aDFFLRnHFniQ0odzC7WIl9",
	"ZdlMlHeVpT2r8BKzl0XX2Rdb9WosepnD5z/U4udULyeJkDoYAs6+E78xeHcUtaIbWnu+htVU42iqHdEf",
	"Ws409dHBpQyJnF3unEoWubcFK5td1kt7rXfWf1pSrTTfSVdsOBdeeyso/vAEVkI8xBO/T9AUhgGso/Zw",
	"3YjNEnWUnKR0Utsq3T8uRiFWtfgx4mK/4d5CS0RZpWvxUhstaZKK8p86vLx47yKcJ4MQ5feFLnOlOUm5",
	"ynyHzyS7PH0/fSPe3lGE1edoP0ZCuEJnvXRi1GfJj5Z2tjk5SpVJ/Tz+1tSaJRNh3UX8N6LOXACLeyq3",
	"Rl/g0UiSXZP15rKdLycr7EWUTxnNPPFtlNLI3wNnCt3ASXznsu4p/CQhscAUlwyW2aFKCu8JCXgOCG4X",
	"SlOoZdiN4yrW1cEZiDiw2r0pZlsk9PdLy+Dt6oLnRC+7FPQiXnC7I0gVrbQLU9DtqpMVx8OW/F6B8lL5",
	"asXAZdViJGX6045P2T61a3DhJu9On6qaOh5N2J8Z/b+nD3R2pjbuTLvvVU0djaf9kTFRNfW93umpmtod",
	"GYbenfLDewk/sj5zDktr7NxdTKQXsrI5/T4pXb236nvk8jwPe3mulpYtUmKla1GC+BbDX6cAryARO1Rb",
	"8lFQ44d1mIqDAs/xUIt3I+UDz3a6AGPEmaoOuEmFHhWOZDKYRH2577HowjHAQOBGGSSvC8MOQxBH7O+f",
	"HTgGIeVUFDV8Bm5A20htvrs+vWieNhuN06aaXZGP2Er1/XOTrk7sZ5P94b9bnxsn58nvi8+Nk4t75vDy",
	"7WwjDyhc6hKGhyD8KmS6cdp427x8Pa6Pvnx5u4NqxV/PPjdOWvfH1XXiA6i8Vvu0pf+MWpbUMOlsf5AK",
	"llVhmzxgZ2nKcNj+ftT46/cjSgmcLBlS+vdbQzvbHB8ft4+P9n1vH39raJebKiw/sZUhQ/fo8z/b92/a",
	"x9+uNvzn8fH33du/8Fd/bbcLrxi2ey3VIK1Go9m2F9ft6wtw1m5fgxZsn1012ldnZ+f7pBIvxH9WuVQq",
	"SVROYwyX6Pm15cRGLx8Tx9+P4r3H5vj7ER0VzfvkQ5MOjOv7FxcsJc82bSXyBQvLbjdb7Xbj7WVpj+OS",
	"fP0+90eSZWUX/D/+otwhrD8c6r1+Z6rPh73pfGQw77DB6O5O76XfMF01ecjCdIzenKuymmoObuemPh6Z",
	"00lS2OzqhXcJ/pvJrUFx1FaCB1aYWOcibmku1mgw6naozj3vDAajT3pv/qk/fT83RtP+bZ9/YRwICo1m",
	"09rlTH0yHhkTPV3G1CdTs9+dioulMSeCyLyjgvyom7lC/41VrW7QL2pbSUy0CuC5GXlVM95vpcjyDV+K",
	"z4+IBMqk8TPoimwBz1YCjB6BtabC237434qT5wEtFc9XktylWep7et+PM4AhbTaLiHkodG1K0Mg4HnrO",
	"ulhU2OMLsGXsMaTcbXGAvD1Or73JgO3TjT/9YOpNBm2FRzQsEX1L3ygO8ujH8cjIfRyPDPYxK2QZ28u2",
	"YSRNL4M46VPOrMQQHJiRi6IsMdW+LJGQ1WOyTae3O5CpZbxgVa+wENbBwMSYPUArCDSOI5WIPH25CFOR",
	"ZWLgr1bIWyVOnmXuFZeNhtZsNRpa67zR0M7o4wX9ddWqH0uXI1UetveCxJi96xE4pRGCLRaPqF00W9ou",
	"WvCscdXSmEvGZfP8/ECSe8ISaxDVzloN7fK8oanIWyIPkXV9lY3Aj63nRF3LGbmgzdYV4M22Ct3eYcdL",
	"bTT1ET4gy4FyYKIBOwQW3caeXxeix7jKz0/CN8dHRye5N98uSpwYtyhrhIz9ABGvE4ZoBk1gI78LgupB",
	"uT003udXVCe7xn53okNyagwX4dJLUpTlzL87M2oEPWuddV26bDXPz6rcJNwE+/ZEpGZuUGGHsaxicoZv",
	"Z+IzuqFl1Um7UApuk246SENw2mfbYz9kebuQt+KHFXKm8jw0nSaqzqdAOjNaVfY3XnCjqZYwTLvSgaU0",
	"uFuM0sAHYOSz40ZTWQSNXEq3lCtgldwY9ukDhuGD79hmyHOPbfvju2o31wICXt2SZLP1cPyadTw6l0cg",
	"zwTKnvxISVx0apQ55rmuaIZ/7Qwi++gkdhPmdpRRFqr9lgpqTBFJdUcVqig7RMnSXhNNWvkoIqnNTVah",
	"SM+uUo24m/Glms61SXz3Alcx5ea6rYfNjmDzsooiBGGEWYrvAYFydcyA7uaIPSQMfCgFA9echFLU+PxX",
	"YxIeCmBiWkF+ATl0xcEs8WuHheZW4TBTZTPgdceEmSktRFE9Isxc+QyaOjOMuS2ZAUXeaorRagXlOoOZ",
	"A67sCSH0Qh+ne6kMuUkeWi5mMZmERdtA4cARmnaGTVVThy363xn973zeG/C/M/b3In6+iJ8v4+fL+Pkq",
	"fr6Kn6/pf+9qb25E4+8Pzmdm/P7W+XGGnkhZbmll+q5XT10uR+DrzwHdm3TpzACxyBVs+6GolRDkwskP",
	"Rask6IW9mlhjblDEObfpQj2Mnf+q2DYjDgEwzlZ7oq1WVqVf8Z3FI6SqPZDvHFbyIe0DVtcJK+2eK1M9",
	"72wVBNPaUUh0Ntw5Xte9QIJ4dfbSU16Kln+qVf4pKR/BQy4xYFDSdxg8XawWwEsbx+vZakX7XkMYmlnf",
	"CTpJZy2TwfpljI1byvcl1ZIxaBsHRGTG2atEBliXWxP26l4Wz4vtVZf0rJK2W6bcoouzxrLvhQR4VjyM",
	"t458UYRs4TSzjA9htzcICIuUflt1gu29LrkpirIpM1qTJMg1AXJdhJPblyvZ2IUFFKKjjbvS+Ojip22E",
	"tAhKbOIz0D439mZzUwYl5ZBeisf3/ps4QTZxwgskPPixdAPC0Z86TO36HsGcsaKSauofZvqE5xIzRtP5",
	"7rmuvicgJTW5CjiVnWspirU4NSnPkiORQHOX5rRqK5UkZqiR5TM+OhSldWDLVcKlcDrClYH970qGMz4g",
	"qr8U1+8R0v9HC9O/OzDM3qsRpRlrFa8aYu+VhdjvmltqLONDg+sN/Ec+MDTCEICye4/CbUx6rUh0Ndzi",
	"2buC7q48yDddTHCL6X4/x1INmKqobAtuH3c3z9Eph34b2Qu65gnujPKBi7zVyF5UGrp2JYVNNLIXfI2P",
	"1dSw6ja0zmAwH3e6P+vT+UQ3P/a7+kTVVHPUGepmfDXe/P14MDTmnXHhw8fkw29xj5p0eoUXyK0wzudL",
	"yp9Y3+s8dFGstmbA6x2B10E48MMwYWh30pTNW9Eor04Cnr8lpoCgjnyI9SCZ/Lw63TnDOgpijzG1PMd5",
	"+c0v+9Od5wgINUBgMw3ED9aqprr+I1TZpWnJD3Z1A20iGJLaOiGja8IwvgA0f1Fc4GNZE3cNjaygYDEy",
	"QrFYF7eO/xRfkiCY01cRuF1giSsLXfAsA7ARM/XBn4wBFsyTgXUxQN7X5IbFmkwFFCO7HlLuyGwLlgh9",
	"r5xzVO7LqrbDKKpevj0qGMwUp1X9FdXYODGtnWraB1sPKB1hDe0oTqcr62+Sht3jsj/+eK5q9M8l/3PO",
	"fsyMydScdacznhpan77XTUOv71ufJS2jKeSYll3iYCHJAHIhiqPjmxeb7/QxfExeXG6+u8ASuEpdbo6P",
	"TiKP4Cgk0D7+63cYIUGx681xafaAMayRn+D1uNuFtebWsMrN1NhxD/cXG2/NsL+D8TIT4G5ZKgcWjrNt",
	"VoLfgbP6+T4OqIPUYEucGOQGmejQXRzUbvCL0+ZdfTCY9+vbfoRXIQpJGKPpfGzq+nA8VTV12Pll+/Qj",
	"tKSEKL62UU6kJfc2VlW5czNgCQJST/LVzpA8rOb52yZlKx9Cz4IlN3WnrhIFJacA0FrJXXmWpG/ca4db",
	"Ze0vcneqFW03NWix84HflI4nKymjjqSC0pYJ4rale39Y4/bSVGGqH2JgfUXeStojLDZsSd7/mu6IdaI7",
	"ftOu+Rv3xv+4Dvif0ufqd7MtfwK13Jh3TL2jaknyz/hpZvxsjD4ZVFU3+LUaEvO9v3Cg24MEICcU+cbH",
	"p6gFedoMRPgJxYe9tQ4qaPFdmpJQwkc3ldyk+qbrZUm32NlHiyptGAV0Uw/tWwhIhKu3ipMCALO44xUk",
	"EyuoKY6y1ExJrQ6MG9umhip6WJRd/4/hCj6XfEnUz333Blekj2F0RSrrhyXKbD8uK+MvPixRzuyWh6k2",
	"usU2g1kIVtDcGo1yFy3El7l89J2o+r5+nuaITveePZV3/NLUX5eVdgYqK96NMTmIRhRIVyjXjpTLAge5",
	"Smt50eUIC7tBLlV9idprzO9uTHaebMy7Zn/a73YG8avMY90pMUdWRvUtJNeXU3lNQPZUlFZIn01NOuN/",
	"GnTodP+xb05nnQGt/E1/RLc6n/qmPugbeurnvBvvB7Yvbm5uVU0dTPWTIQU157MENfs1NWeTqd6bG2d3",
	"ndRjTDPm4E43O7VFGldMRpSJLORFiLzVXV0nH34ZpgmXU5/fqis+OIpDqIVLSME9Mykq6tI5SlICyTEp",
	"Kxi4ZCFJj/CDP+ls78cXe2l8GE3YgJqzX7VbWUhCso4iJqWrmnXdF7ogay3tXLvWmpfaWUu7PD8g7LTo",
	"4C+OfWVhvdr5NQ9vLb+ikwX+xlG/jYbWvG6k3jYO42pfTG4Nvuhzg8Xo/hY8io3zta7dLT2CysY7CHv3",
	"WDf7ox5dFuis91E3pvOp2b+7k3BCKsRB1CXUaaV+zpMCqsbOh01zOE/zY8oMPZ48Y69VP0keQncNk9gB",
	"K/vuQHJyQzzLqezYXoZB37O5Wpo69risiijeAuavJsiDViuK5uoTwtBBHuw+AAwsAjEKCbLC2ubuUgxS",
	"kixlQ1amGbcI4U0Tk35Pn78fDfX5eDA0+AY0+27eHc2MqflL/T7kRwTmXKb2G1bQAV7t6ACf9kO8+vPz",
	"0w6FcJaidZ/6aR+3ndgzp8qJkASp/+mnMfaXSe7z/cKzvWqvIXbvI63Jlmqlm0yuDRPgmK/qu98K18wB",
	"VCqx2PzyGllGNBVLUth/8z0uyU4yAS7dFa2oGuvnj+CqprgMcNELRXaam1gP0I4caHd91408tPMFFOyL",
	"wTosuyk6le+H3cIK1kfhcXIn6xOEX0+V/lIBixB6RFMQ2V7ZHCrwEeI1hcgUV7WaFzBub6/OxONeVqbG",
	"duFo2QNr3asOuknKZgAndCssASoy15RLX2aN2NOGkotECabyjFijT8agb/yc5KGbjdNPN/1e39S70/7I",
	"6AxqLxnlPLyATA5QRia2mbh3ZLt8R2F+H7TXTnqhcjRxkAWVHmK3/noEAeLj8Fgt3Ffh7XO7LnEdDpPO",
	"JgMm7HHQ8j0b4LUJCDOCiU/egq0rBiuUbJhrjUhu7KHdz44tbFWG21+5US6UpyUw51VHK+8kUCu4OrFR",
	"5F1m83ju64i7zOb4P0MEoqYUi8VZilOzhdBZ1stsVuDFWZbQyseXi2/D75ijoT41+9352NQnk5mp0wlN",
	"n0/GOnOEmunzkdnXjSnP6Vl7OsvcAvQKOk34ojpNWKbT7KqZ2vxl8+vuEth5PuFem5nYlcyW8X6T14UB",
	"hiCkWjD9sGvAGFfeH7SwVU67UFRtiItxNQLeBJVwwbMRuaPltEMZ/VFOfwcub31s+EkqlE4s4I3osjH2",
	"rfbV03FClkLOkJR8JKIz9zMsgUggbCkzxqa859eI2NqaoicucNgN/iYgsCwGBEMXIE9/5nN6yKMb9x+Q",
	"5UBmtUG4b7sEjRigDgV2gIvIOtlT1A4tKkp6GxWTWzMOUaj46b5UDrfMclPilpy/9rGgNeqFBK8cRLEB",
	"AQpJLmTO1s+UCzhMVNYqPeAJObYFsD2x69zcKmyS0Br6dsnuYDLpzoejnj5vqtruoZV+OKu/jnJKUnuA",
	"mDlZhZ+wvQLA6z7fo5aGOUy4LtAx6W5nOLrpl/ng/YlSA+9kkkkCTCnOdIVVPBGvcqJwoZWUdP0FcuKk",
	"waJGkeoLokaV7hjeRHwbJPsidhsrlo0WVIoLaPf4gPvgC2b/i9rBBwAH1ctx8DIx4ekZkHLIqQvnwSgQ",
	"uOOHKHMdnwfQyemb7yuL/3HYnzKvdYpxhCeRVR+vk0YfRhY6OWqIrs37/rl5cnV/cvrmOHG/1843tGyD",
	"An7mfvXNk3f3J+wmB8FdMN9aG+FNMCcxMEtGc7y3bnUCBn5QfkU/J/Gi+Rchgml+I3GUWWjPNz8dfz/K",
	"r73HJZjEZgcCLEm/O0sugCshIOqyU1CZNeoHavxDSW+kb/4EVi3Rle31SMkubwqkktxMgXSOm53BtKA5",
	"TfiKyZdEdhihBAATBJwTglyo+FhZRk78AML0emc5IAqhcnF6SZe5vj69VczbrnJ2dvbuVNH5JTKhprQa",
	"7eZFu9HY/TppXLcbDeVo6WPlWnnwIxwqC/iAPFuZTbvHp8K2Ri78h++Jve2SjzUXi+k2i1TuluwwLHF1",
	"tNAjYnmjYVj/qLIEm0jj4xxJ9YIkx5VcR9heXiuT2muKgbU1n+0/K9vl/NU9gsj6kHRaAhzSB5GZVMEy",
	"dWW5b5fAgocA8xRdh0ASJmIYVKc/mO5KJnAmvxMhlzWDLsepS2zrGLYzk3qCOcNcpo5pMQsntkylBHkX",
	"+0Z/OBtSNV/v9fmPzt+TV/zj/NNo/lE3eiNzrv99qhsTfvUPByj7yJEIv9bdGe14lxqV6caRG5kYLJfI",
	"GmN/iZyyrV/fuBvo86nZMSY81WTmDUtC2Zt1BtsS89u+ye4/Tb3t7d4OZ4Npn7/+7w4rK9u2MmM+tkqI",
	"vJUDlYCZZhSCgRe6iJ3hnOaheoO20otddSvgBK3UVnoRcEQAmrJEOCTOWuF+v6IyXOJhtAhZJn6iJD7D",
	"NTjoSXCwD22Bh3J2T/n+M9vpJQdaerjIDranV1YAskavEo9XzqWUVJ4OUgrWAew4yW1S3djyVFhNrsU2",
	"v9me2946s+n7kdn/xzZpWepF3Yl4hjzSvMwGKFxcnFUG63O4fGhDEbLamyM2MWeu0Wi9O393edV6V4uN",
	"0uueK/HVY45fCL1zWLk+P7+8Oj9vXJ1dNd5dXLRq5GHhaPKeL5WI6vEHYz/Pahbo71xWnHpUAnYVB7N3",
	"gfJAX1P/MOvzDAxjU7/VTXPbMw1d78n0yjxBmWFa5FZyxM6CPq07/l0quiUlV8Udh9KVm0ArSuqWnaCj",
	"WHKVp0ICCatRzFM1cIr33GS9xaHteBHN3btKyEltW3VZoWEkXLdmGNXcFM8wYreileieD4QEqsb+hPU7",
	"Twj3ZCOEEcGZjNh7o3gzhXm+6drAmdTbLKaxNmQqUZ5o4z7LVWF3Gp+JbFmhohdqCAQvMXtZPCh+scSN",
	"NfIddqHj8Chkbvf64+R6dKodcXOX6jH3U1THGXfnIsvcO6rzBGZcUF4g6WOhb30EeAaL6Y3LDNZuiELb",
	"y3yBzwTZJ5//+bf7N39j/9e0aseUDzeevyQvBce31w4tfc2A0ZcPFf3UOcQk+Ck+5O55hUH8l/sqiOo0",
	"t6U4eNSG+DI6gCGgu5ebOo40XX6GvQXqygDx3A4D5MG+HUpkdqhO/PGwtAwZnO9Z+QNScySiLHcx+xFX",
	"pUxDbYQZmV/YZWjDE4VD7AGn5/OAoqzd5+xuPFamE6X17vTiqql0fdf1PaUHCFAoUmbKUmJxKDcghLbS",
	"T4zBoba1NzUvT69OG3RkYUdtM4Wo/fbt09PT6dkqCE59vHq7JMHbSQCt8C3A1gN6hG9b7+YhxAiGbzn1",
	"t9zUzE/rsmzK8XX6xft//1dpNVpNTWEVHOEV8NC/+bm8o4wBJh7EoXLUMfs3mtKZ9iea0u1OOpqiTyd9",
	"TZlOeuzPtEP/6x6ffvE6jqNgtHogoYJhCPEjtGPTGs+vUORR1dRYPmpbbZ62Ts94Xk3ogQBR2Z82mMwC",
	"QB5Clhzz/wcAAP//CEJTfPPPAAA=",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %s", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	var res = make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	var resolvePath = PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		var pathToFile = url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
