// Package invokermanagementapi provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.9.1 DO NOT EDIT.
package invokermanagementapi

import (
	"bytes"
	"compress/gzip"
	"encoding/base64"
	"fmt"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/deepmap/oapi-codegen/pkg/runtime"
	"github.com/getkin/kin-openapi/openapi3"
	"github.com/labstack/echo/v4"
	externalRef0 "oransc.org/nonrtric/plt/capif/internal/readonly/common"
	externalRef1 "oransc.org/nonrtric/plt/capif/internal/readonly/common29571"
	externalRef2 "oransc.org/nonrtric/plt/capif/internal/readonly/publishserviceapi"
)

// ServerInterface represents all server handlers.
type ServerInterface interface {

	// (POST /onboardedInvokers)
	PostOnboardedInvokers(ctx echo.Context) error

	// (DELETE /onboardedInvokers/{onboardingId})
	DeleteOnboardedInvokersOnboardingId(ctx echo.Context, onboardingId string) error

	// (PUT /onboardedInvokers/{onboardingId})
	PutOnboardedInvokersOnboardingId(ctx echo.Context, onboardingId string) error
}

// ServerInterfaceWrapper converts echo contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler ServerInterface
}

// PostOnboardedInvokers converts echo context to params.
func (w *ServerInterfaceWrapper) PostOnboardedInvokers(ctx echo.Context) error {
	var err error

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostOnboardedInvokers(ctx)
	return err
}

// DeleteOnboardedInvokersOnboardingId converts echo context to params.
func (w *ServerInterfaceWrapper) DeleteOnboardedInvokersOnboardingId(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "onboardingId" -------------
	var onboardingId string

	err = runtime.BindStyledParameterWithLocation("simple", false, "onboardingId", runtime.ParamLocationPath, ctx.Param("onboardingId"), &onboardingId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter onboardingId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.DeleteOnboardedInvokersOnboardingId(ctx, onboardingId)
	return err
}

// PutOnboardedInvokersOnboardingId converts echo context to params.
func (w *ServerInterfaceWrapper) PutOnboardedInvokersOnboardingId(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "onboardingId" -------------
	var onboardingId string

	err = runtime.BindStyledParameterWithLocation("simple", false, "onboardingId", runtime.ParamLocationPath, ctx.Param("onboardingId"), &onboardingId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter onboardingId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PutOnboardedInvokersOnboardingId(ctx, onboardingId)
	return err
}

// This is a simple interface which specifies echo.Route addition functions which
// are present on both echo.Echo and echo.Group, since we want to allow using
// either of them for path registration
type EchoRouter interface {
	CONNECT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	DELETE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	GET(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	HEAD(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	OPTIONS(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PATCH(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	POST(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PUT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	TRACE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
}

// RegisterHandlers adds each server route to the EchoRouter.
func RegisterHandlers(router EchoRouter, si ServerInterface) {
	RegisterHandlersWithBaseURL(router, si, "")
}

// Registers handlers, and prepends BaseURL to the paths, so that the paths
// can be served under a prefix.
func RegisterHandlersWithBaseURL(router EchoRouter, si ServerInterface, baseURL string) {

	wrapper := ServerInterfaceWrapper{
		Handler: si,
	}

	router.POST(baseURL+"/onboardedInvokers", wrapper.PostOnboardedInvokers)
	router.DELETE(baseURL+"/onboardedInvokers/:onboardingId", wrapper.DeleteOnboardedInvokersOnboardingId)
	router.PUT(baseURL+"/onboardedInvokers/:onboardingId", wrapper.PutOnboardedInvokersOnboardingId)

}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+xa3W7jxhV+lcGkFwnAJSV6ncC6U+RsSjSNhZW2vYgXxpA8FCcezrAzQymqIaCv0Tvf",
	"9jX8KH2SYn4kURLlda02CDZaLHZtas7/Od85h6MHnImqFhy4VnjwgFVWQkXsj8NxkvC5uAf5HZeCVcD1",
	"NWhCmf00B5VJWmsqOB7ghBdCVsT8hkgqGo10CWg4TpBngXRJNJLwtwaUhhxpgQRPBZE5DnAtRQ1SU7Cc",
	"SU09UZIfSjI8qeeZXCOiFJ1xyFG6tCJHw3HyDmVCAioanlmFtNhos6ZclJQBEvyNVYHy2f6JEE1Kwhji",
	"QqMUUC1BAdeIcnvwj9PpGI1vJtO1RaiQojqQ4gV36BQ4BzjxiGoFrFiL3BVnnghdgnRCvTyFCM+RBFUL",
	"rkCFOMASSH7D2RIPtGwgwHpZAx5gpSXlM7wK2n7dRuvQwd8DB0kzRFshlcCIj9q+jarJSkQUyl1qIFHY",
	"IznMaQZISPsbqWtGM8vLqNql2g9UaaPMHyQUeIC/iLZ5GfmkjIbjxB5bBZgLTQvP8hqUpnxjjucwncRX",
	"/Ti+G4mqEvyaaBIuScU6GX+Q1DD1GUn5bM9Dzyl100m0MgGxoZqC0j+2tD30+AS09axswKTxpEnNp6lL",
	"oHWCPZPcCniOCNLmWNsvLiwFNeVBufmrmjRjpFGAvgm/DpEXXBCmbKhERbUJs823BVXQClYqBANiDVNN",
	"XQupIX8HRDfSVW3L65ff9F/k9ckBn1WAF5Aqkd1bj40EL+jslTH96yGjlY8KlZDjwU9H4n08uT5uvCHS",
	"nyGzibjOyYOoTktAjCptKkKBtOUwHCfKIeE+PFJlKl0sXJG54sIBphqqfffGxgEmE+7GTcqoKu8mjv3d",
	"cJw84213aDhOrlt6rgJcUZ44Mf2NfURKsjQf3hwriWOYPTIPrfOg2yctq//9j38qNPN4kzFqIC/b0geo",
	"lmJO82fR/RieeBHWRdmfYPkyZWp7HN3DsovtNl8mkEnQL+O5pULKkr3Wrr3s7TKyK0O3IdyHoWMx7Or3",
	"n8DlY5SvAncJSjQygx9E9j9AdQmqYfoo7N5iA7y3GFGe27QzLS0DpYqGtSeEEN2sYRGpNamFzlvcAZN7",
	"wfJKHMbHHIRfNEhO2LXIOmari+/H46fH6eTpMb4K4zh+evxL/+vwIuw9PTov2Ix7J0kFCyHvUSEkMjTo",
	"RyF1mYqG5xZ4cIAbyfAAl1rXgyhaLBbhxayuQyFnUaHraFJDpiIis5LOIYqv7hRICipyYiPjSzMUdM9k",
	"Rmp7LqgIJzMwqRDe8qd/obgX9wKn142cEU7/bkNLGBoTqTlIhb4cvk++DdBwmkwCNBpNhgH6bjpJAjSd",
	"XNv/pkPzz+ir8JYPGUOSzkqtzBQEcg55eGuwW1PNjH8dQg7HyZ1Pzbs/bzQyj3GA5yCVM6Af9sOerfAa",
	"OKmp8XrYC3tmNiW6tEGJfB1D7hnap7VwmZ0RxlKS3duHzwwnD76fh6nIl19ER06u2qx3fW1reHnQP7ZD",
	"dwtuTE0w8E3NC/5W5BYLM8E1cO0KfzOdRT8rp6eroZfPPjvQstrNflNfrg7dtGq4xr23XbahkVMLfblT",
	"hBuL2v76ygTsba/3X6LDRo3I0FoW/RNY9B2LixNYXDgWb09g8day6J9gSN8Z0j/BkL4zpH95AotLyyK+",
	"ej2L+MqwuDwhLy5dXlyeENRLF9QcCuJ7z6vYrOlX9k+wVy4jCUSDQgRxWNj2Nad5Q9gOMNRSFJTZSd40",
	"e1s5Zq/GY6H0zQGk/X9w4rkB4SVY0f/VNDn+smE9CkDeGhCYmRNLILlvB+2JZS9YgmtCubIY/eF9sl6U",
	"OSzYEmU2lHajt5NPgEiWCf9mwi3dSssmM2vSAD2Qmr4XQq8iUtM3XsE3244bzfuH3Sp6aK07+Qrvez1o",
	"eXB/8DSeiXtx97zbGl5LooziUNuXBSWgbYPYLLKE52bbqaUwPjSfUB2eofwM5b8fKA/wp8vTlhqDri36",
	"2j5XiPAjoH8I9o7kAO5b2719D0vMEqEtlv10sC5ZMEA0B24mUPPzrgItgGzj5hrSsNke8MAO1DjAnFR2",
	"DdrV4OWQ9PElA6WBpyN9sSI6K40RbQ3QgigkisLbcYalfVg6V/NBNQe4bn5jK2C7/Jo6Jxo+l1Www7Lz",
	"SnieI84roS+bD7YmukaDddX4e7qOfbDRn9188Otvsrs+keBvct19nF/5OsJhlrwUPKTZ27qOKwH8aSTt",
	"/QYW5bVJa2N2tuXXLpIdwL+Wc14szw3h3BCw7wf2LsQDtLvuecHbIhzgOZGUpGxzFWgoXJl69ey1kRpE",
	"EfxCzCwZZqLC+zjgCfe+edD+2sGlQUF7DTSdIHezZFT/uPpPAAAA//9fYNj5iiQAAA==",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %s", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	var res = make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	pathPrefix := path.Dir(pathToFile)

	for rawPath, rawFunc := range externalRef0.PathToRawSpec(path.Join(pathPrefix, "TS29122_CommonData.yaml")) {
		if _, ok := res[rawPath]; ok {
			// it is not possible to compare functions in golang, so always overwrite the old value
		}
		res[rawPath] = rawFunc
	}
	for rawPath, rawFunc := range externalRef2.PathToRawSpec(path.Join(pathPrefix, "TS29222_CAPIF_Publish_Service_API.yaml")) {
		if _, ok := res[rawPath]; ok {
			// it is not possible to compare functions in golang, so always overwrite the old value
		}
		res[rawPath] = rawFunc
	}
	for rawPath, rawFunc := range externalRef1.PathToRawSpec(path.Join(pathPrefix, "TS29571_CommonData.yaml")) {
		if _, ok := res[rawPath]; ok {
			// it is not possible to compare functions in golang, so always overwrite the old value
		}
		res[rawPath] = rawFunc
	}
	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	var resolvePath = PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		var pathToFile = url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
