// Package invokermanagementapi provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.9.1 DO NOT EDIT.
package invokermanagementapi

import (
	externalRef0 "oransc.org/nonrtric/plt/capif/internal/readonly/common"
	externalRef1 "oransc.org/nonrtric/plt/capif/internal/readonly/common29571"
	externalRef2 "oransc.org/nonrtric/plt/capif/internal/readonly/publishserviceapi"
)

// Information about the API Invoker that requested to onboard
type APIInvokerEnrolmentDetails struct {
	// API invoker ID assigned by the CAPIF core function to the API invoker while on-boarding the API invoker. Shall not be present in the HTTP POST request from the API invoker to the CAPIF core function, to on-board itself. Shall be present in all other HTTP requests and responses.
	ApiInvokerId *string `json:"apiInvokerId,omitempty"`

	// Generic information related to the API invoker such as details of the device or the application.
	ApiInvokerInformation *string `json:"apiInvokerInformation,omitempty"`

	// The list of service APIs that the API Invoker is allowed to invoke
	ApiList *APIList `json:"apiList,omitempty"`

	// string providing an URI formatted according to IETF RFC 3986.
	NotificationDestination externalRef0.Uri      `json:"notificationDestination"`
	OnboardingInformation   OnboardingInformation `json:"onboardingInformation"`

	// Set to true by Subscriber to request the CAPIF core function to send a test notification as defined in in subclause 7.6. Set to false or omitted otherwise.
	RequestTestNotification *bool                            `json:"requestTestNotification,omitempty"`
	SupportedFeatures       *externalRef1.SupportedFeatures  `json:"supportedFeatures,omitempty"`
	WebsockNotifConfig      *externalRef0.WebsockNotifConfig `json:"websockNotifConfig,omitempty"`
}

// The list of service APIs that the API Invoker is allowed to invoke
type APIList []externalRef2.ServiceAPIDescription

// OnboardingInformation defines model for OnboardingInformation.
type OnboardingInformation struct {
	// The API Invoker’s generic client certificate, provided by the CAPIF core function.
	ApiInvokerCertificate *string `json:"apiInvokerCertificate,omitempty"`

	// The API Invoker’s public key
	ApiInvokerPublicKey string `json:"apiInvokerPublicKey"`

	// The API Invoker’s onboarding secret, provided by the CAPIF core function.
	OnboardingSecret *string `json:"onboardingSecret,omitempty"`
}

// OnboardingNotification defines model for OnboardingNotification.
type OnboardingNotification struct {
	// Information about the API Invoker that requested to onboard
	ApiInvokerEnrolmentDetails *APIInvokerEnrolmentDetails `json:"apiInvokerEnrolmentDetails,omitempty"`

	// The list of service APIs that the API Invoker is allowed to invoke
	ApiList *APIList `json:"apiList,omitempty"`

	// string providing an URI formatted according to IETF RFC 3986.
	ResourceLocation *externalRef0.Uri `json:"resourceLocation,omitempty"`

	// Set to "true" indicate successful on-boarding. Otherwise set to "false"
	Result bool `json:"result"`
}

// PostOnboardedInvokersJSONBody defines parameters for PostOnboardedInvokers.
type PostOnboardedInvokersJSONBody APIInvokerEnrolmentDetails

// PutOnboardedInvokersOnboardingIdJSONBody defines parameters for PutOnboardedInvokersOnboardingId.
type PutOnboardedInvokersOnboardingIdJSONBody APIInvokerEnrolmentDetails

// PostOnboardedInvokersJSONRequestBody defines body for PostOnboardedInvokers for application/json ContentType.
type PostOnboardedInvokersJSONRequestBody PostOnboardedInvokersJSONBody

// PutOnboardedInvokersOnboardingIdJSONRequestBody defines body for PutOnboardedInvokersOnboardingId for application/json ContentType.
type PutOnboardedInvokersOnboardingIdJSONRequestBody PutOnboardedInvokersOnboardingIdJSONBody
