// Package providermanagementapi provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.9.1 DO NOT EDIT.
package providermanagementapi

import (
	"bytes"
	"compress/gzip"
	"encoding/base64"
	"fmt"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/deepmap/oapi-codegen/pkg/runtime"
	"github.com/getkin/kin-openapi/openapi3"
	"github.com/labstack/echo/v4"
	externalRef0 "oransc.org/nonrtric/plt/capif/internal/readonly/common"
	externalRef1 "oransc.org/nonrtric/plt/capif/internal/readonly/common29571"
)

// ServerInterface represents all server handlers.
type ServerInterface interface {

	// (POST /registrations)
	PostRegistrations(ctx echo.Context) error

	// (DELETE /registrations/{registrationId})
	DeleteRegistrationsRegistrationId(ctx echo.Context, registrationId string) error

	// (PUT /registrations/{registrationId})
	PutRegistrationsRegistrationId(ctx echo.Context, registrationId string) error
}

// ServerInterfaceWrapper converts echo contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler ServerInterface
}

// PostRegistrations converts echo context to params.
func (w *ServerInterfaceWrapper) PostRegistrations(ctx echo.Context) error {
	var err error

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostRegistrations(ctx)
	return err
}

// DeleteRegistrationsRegistrationId converts echo context to params.
func (w *ServerInterfaceWrapper) DeleteRegistrationsRegistrationId(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "registrationId" -------------
	var registrationId string

	err = runtime.BindStyledParameterWithLocation("simple", false, "registrationId", runtime.ParamLocationPath, ctx.Param("registrationId"), &registrationId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter registrationId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.DeleteRegistrationsRegistrationId(ctx, registrationId)
	return err
}

// PutRegistrationsRegistrationId converts echo context to params.
func (w *ServerInterfaceWrapper) PutRegistrationsRegistrationId(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "registrationId" -------------
	var registrationId string

	err = runtime.BindStyledParameterWithLocation("simple", false, "registrationId", runtime.ParamLocationPath, ctx.Param("registrationId"), &registrationId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter registrationId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PutRegistrationsRegistrationId(ctx, registrationId)
	return err
}

// This is a simple interface which specifies echo.Route addition functions which
// are present on both echo.Echo and echo.Group, since we want to allow using
// either of them for path registration
type EchoRouter interface {
	CONNECT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	DELETE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	GET(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	HEAD(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	OPTIONS(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PATCH(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	POST(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PUT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	TRACE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
}

// RegisterHandlers adds each server route to the EchoRouter.
func RegisterHandlers(router EchoRouter, si ServerInterface) {
	RegisterHandlersWithBaseURL(router, si, "")
}

// Registers handlers, and prepends BaseURL to the paths, so that the paths
// can be served under a prefix.
func RegisterHandlersWithBaseURL(router EchoRouter, si ServerInterface, baseURL string) {

	wrapper := ServerInterfaceWrapper{
		Handler: si,
	}

	router.POST(baseURL+"/registrations", wrapper.PostRegistrations)
	router.DELETE(baseURL+"/registrations/:registrationId", wrapper.DeleteRegistrationsRegistrationId)
	router.PUT(baseURL+"/registrations/:registrationId", wrapper.PutRegistrationsRegistrationId)

}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+xY3W7juBV+FYItsC2gSLYz6SK+8+Zna2ynY8Te9mJmENDikc0tRWpJKh43yAP1Nfpk",
	"xSEl2bJkZ2Yz/UE3NzOxpPP/ne8c8pGmOi+0AuUsHT9Sm64hZ/7PyWw6M/pBcDA3ymiZg3LX4JiQ/nVh",
	"dAHGCfC/WCHw42udTzn+5mBTIwontKJjVEWKShfhOmdCkek1YdaKlQJOllvi1kCuJrPpLUm1AZKVKkVh",
	"4rR/hRpyptgK0I3d681aSCAGVsI6MEKtmq8P7MVkvmZSEqUdWQIpDFhUJJQX+ONiMSOzd/MFMfBzCdaR",
	"zOi80fW2x3LlWI/PEb7T6mypmeFEOAsyq823TeMT7dZgggOVbUuY4sSALbSyYGMaUQOMv1NyS8fOlBBR",
	"ty2Ajql1GDJ9ivbzrzLdrcD3oMCIlAiVaZMzH4EByRzw/RQfFsmW6ZowS3ioO9FZ91NWFFKkXqX39Zhv",
	"t6VKbQ82iBTWoWahuHgQvGSy15c6vY03MfnrGhQRKpUl36HoGFT2S11XOQdr2QoiIpx3wx7NxM66WzP3",
	"jCEHilvMaw3MpCw4c4A+hEcmlEAbUr1pPS6MToGXBo6E2Nco7fACdk7EdyypITxmdk0FfOcmR0SkYG1W",
	"SrnFagsHua/qbw1kdEx/k+wIJanYJNmjktvKYM0kTxHNhZoGLcMGPcwYtsWXGRPyDphFrBxC564/lbaA",
	"VGQiJShbGmiBXmf+MfCTVW6Vw8Z9vdtN9lLzLREZYU4CQ0gr6G2YU7aOISLzgO/rLgOrOaTd5MwhLY1w",
	"21b0CrB4zGxJps0pzn1gUngv8Ju2g9lzFNvO0xFqPdY8Tve6hO72JXHftd702LIoboG5PYgu5qPLi2+H",
	"91c6z7W6Zo7FW5bLXuTOy6LQxgFHHaUBS598zn8uhQFOx+/r/H9sbOvlT5A6tH0C9scGKH73uRO0Ts6X",
	"T9KjUOyM00Bc/665mn/5XK19+zpz9dSs+qqDtAnva0/UOy3hWfoNn9c49CKBOeoYT0nvs+x0F3VfI3h1",
	"Xfd6e6PHJ2wDtX2X0fH7RwqqzFHt5OaWYiv5f9/e7ilr8nFYo8VaWBLe1km1yCAbZvgZRsicWErkxo1w",
	"a5KV2NkEPjlQNoz4UEh0ASraW5aOCOthXtpQa1Cp5kBSjfPeEQ6ZwBasoF/D8QGMbXhTWKx0TD6oblk/",
	"RgdhzLS1YikBybgE64fyGZnc3I7bcNmtAF47uflUaIux16QTo9jsObFZuZTCrjuCbyvB2THBve24Efyg",
	"sMjHoHOM/a7AuC/jvm8sSaVA0ylqy7Bt4ETLzMrlD7Dt2vDBp+QH2GKhWuEeWOxpyINGaJvqgh+/R7AZ",
	"xeS17tuJz7+fzchiTkaX8Wg0In8Z/iE+jwckDCzv3a1hOWy0+ZufjP77P2vj1ktdKr/aWBrR0kg6pmvn",
	"inGSbDab+HxVFLE2qyRzRTIvILUJM+laPEAyury3YATYJBhNMGmilwLR/rF5vNsnd9wef1D//AcZDUaD",
	"KHj6zqyYEn/3WGCSzJhxCowlv5vcTb+LyGQxnUfk6mo+icjNYj6NyGJ+7f9bTPCfq9/HH9RESmLEau0s",
	"MjqYB+Bx6CrhkEqoHyD3k9n0vq7k/Q6o+JxGtOpNOqbDeBAPMGRdgGKFwCL4RxEtmFv7GiWtpdCDWFt3",
	"bC3FgBhRsOlFkyee0wksjM6EDHMKeyV0EQ/E4O5avgQAgnXfae7RXZFS6K1mmiQ/VXt04PYvWNs7NwBP",
	"bdTjsdQ/qIYrqh4Nhv85V56njL3zzP4hhkZ0DYyD8T7/SacNRbVVXmnlmFDhBPXj3bSe3Ao2cktSA34F",
	"MGB1aVKICEtTbbjfnMI0sc6UKU6aMXlkhbjT2j0lrBBntaNnu5ZJHoZttCWP+z+n/IkeZj/ay+QhP2GC",
	"3gwGBzvwcDQ6uQM3xUxQ1qsYvkDFMKg4f4GK86DizQtUvPEqhi8IZBgCGb4gkGEIZHjxAhUXXsXo8per",
	"GF2iiosX4OIi4OLiBUW9CEXlkLFSul+sppYPWH+ud3xzS3DQbfNrMA1997HIcku8KDZ233s8YjQc3qXu",
	"a2+2Rd6tJYn7gYPD3XlGet851oe1VnBQTmRb/Ju1uK2f+gIrURzpdOxHGo2oYjnShDl04POJ5WOH8t90",
	"U7o4cibKmUv9utl2ANfKUB0e01fiahPXa793+j2iRdmzhf3ob9HwzN8Hvm9s+1arvlLu7lql+//q1v/C",
	"mtjOiYHqaPzcfWJvhXCbWkJzHS1U300RfX41HfzvraYHgfbduL/y4esi9+tZ5J4i6k/2FbWG64zPOTvh",
	"0Z4ZwZayuV5CkTAkKv/8vYgdJwl8YnkhIU51Tg+btRIMF7bN9Z4tl6lkpQXybXyBBNa+r0HfPz79KwAA",
	"///94pZMWh8AAA==",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %s", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	var res = make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	pathPrefix := path.Dir(pathToFile)

	for rawPath, rawFunc := range externalRef0.PathToRawSpec(path.Join(pathPrefix, "TS29122_CommonData.yaml")) {
		if _, ok := res[rawPath]; ok {
			// it is not possible to compare functions in golang, so always overwrite the old value
		}
		res[rawPath] = rawFunc
	}
	for rawPath, rawFunc := range externalRef1.PathToRawSpec(path.Join(pathPrefix, "TS29571_CommonData.yaml")) {
		if _, ok := res[rawPath]; ok {
			// it is not possible to compare functions in golang, so always overwrite the old value
		}
		res[rawPath] = rawFunc
	}
	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	var resolvePath = PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		var pathToFile = url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
