// Package publishserviceapi provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.9.1 DO NOT EDIT.
package publishserviceapi

import (
	"bytes"
	"compress/gzip"
	"encoding/base64"
	"fmt"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/deepmap/oapi-codegen/pkg/runtime"
	"github.com/getkin/kin-openapi/openapi3"
	"github.com/labstack/echo/v4"
	externalRef0 "oransc.org/nonrtric/plt/capif/internal/readonly/common"
	externalRef1 "oransc.org/nonrtric/plt/capif/internal/readonly/common29571"
)

// ServerInterface represents all server handlers.
type ServerInterface interface {

	// (GET /{apfId}/service-apis)
	GetApfIdServiceApis(ctx echo.Context, apfId ApfId) error

	// (POST /{apfId}/service-apis)
	PostApfIdServiceApis(ctx echo.Context, apfId ApfId) error

	// (DELETE /{apfId}/service-apis/{serviceApiId})
	DeleteApfIdServiceApisServiceApiId(ctx echo.Context, apfId ApfId, serviceApiId ServiceApiId) error

	// (GET /{apfId}/service-apis/{serviceApiId})
	GetApfIdServiceApisServiceApiId(ctx echo.Context, apfId ApfId, serviceApiId ServiceApiId) error

	// (PUT /{apfId}/service-apis/{serviceApiId})
	PutApfIdServiceApisServiceApiId(ctx echo.Context, apfId ApfId, serviceApiId ServiceApiId) error
}

// ServerInterfaceWrapper converts echo contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler ServerInterface
}

// GetApfIdServiceApis converts echo context to params.
func (w *ServerInterfaceWrapper) GetApfIdServiceApis(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "apfId" -------------
	var apfId ApfId

	err = runtime.BindStyledParameterWithLocation("simple", false, "apfId", runtime.ParamLocationPath, ctx.Param("apfId"), &apfId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter apfId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetApfIdServiceApis(ctx, apfId)
	return err
}

// PostApfIdServiceApis converts echo context to params.
func (w *ServerInterfaceWrapper) PostApfIdServiceApis(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "apfId" -------------
	var apfId ApfId

	err = runtime.BindStyledParameterWithLocation("simple", false, "apfId", runtime.ParamLocationPath, ctx.Param("apfId"), &apfId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter apfId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostApfIdServiceApis(ctx, apfId)
	return err
}

// DeleteApfIdServiceApisServiceApiId converts echo context to params.
func (w *ServerInterfaceWrapper) DeleteApfIdServiceApisServiceApiId(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "apfId" -------------
	var apfId ApfId

	err = runtime.BindStyledParameterWithLocation("simple", false, "apfId", runtime.ParamLocationPath, ctx.Param("apfId"), &apfId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter apfId: %s", err))
	}

	// ------------- Path parameter "serviceApiId" -------------
	var serviceApiId ServiceApiId

	err = runtime.BindStyledParameterWithLocation("simple", false, "serviceApiId", runtime.ParamLocationPath, ctx.Param("serviceApiId"), &serviceApiId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter serviceApiId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.DeleteApfIdServiceApisServiceApiId(ctx, apfId, serviceApiId)
	return err
}

// GetApfIdServiceApisServiceApiId converts echo context to params.
func (w *ServerInterfaceWrapper) GetApfIdServiceApisServiceApiId(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "apfId" -------------
	var apfId ApfId

	err = runtime.BindStyledParameterWithLocation("simple", false, "apfId", runtime.ParamLocationPath, ctx.Param("apfId"), &apfId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter apfId: %s", err))
	}

	// ------------- Path parameter "serviceApiId" -------------
	var serviceApiId ServiceApiId

	err = runtime.BindStyledParameterWithLocation("simple", false, "serviceApiId", runtime.ParamLocationPath, ctx.Param("serviceApiId"), &serviceApiId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter serviceApiId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetApfIdServiceApisServiceApiId(ctx, apfId, serviceApiId)
	return err
}

// PutApfIdServiceApisServiceApiId converts echo context to params.
func (w *ServerInterfaceWrapper) PutApfIdServiceApisServiceApiId(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "apfId" -------------
	var apfId ApfId

	err = runtime.BindStyledParameterWithLocation("simple", false, "apfId", runtime.ParamLocationPath, ctx.Param("apfId"), &apfId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter apfId: %s", err))
	}

	// ------------- Path parameter "serviceApiId" -------------
	var serviceApiId ServiceApiId

	err = runtime.BindStyledParameterWithLocation("simple", false, "serviceApiId", runtime.ParamLocationPath, ctx.Param("serviceApiId"), &serviceApiId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter serviceApiId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PutApfIdServiceApisServiceApiId(ctx, apfId, serviceApiId)
	return err
}

// This is a simple interface which specifies echo.Route addition functions which
// are present on both echo.Echo and echo.Group, since we want to allow using
// either of them for path registration
type EchoRouter interface {
	CONNECT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	DELETE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	GET(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	HEAD(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	OPTIONS(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PATCH(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	POST(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PUT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	TRACE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
}

// RegisterHandlers adds each server route to the EchoRouter.
func RegisterHandlers(router EchoRouter, si ServerInterface) {
	RegisterHandlersWithBaseURL(router, si, "")
}

// Registers handlers, and prepends BaseURL to the paths, so that the paths
// can be served under a prefix.
func RegisterHandlersWithBaseURL(router EchoRouter, si ServerInterface, baseURL string) {

	wrapper := ServerInterfaceWrapper{
		Handler: si,
	}

	router.GET(baseURL+"/:apfId/service-apis", wrapper.GetApfIdServiceApis)
	router.POST(baseURL+"/:apfId/service-apis", wrapper.PostApfIdServiceApis)
	router.DELETE(baseURL+"/:apfId/service-apis/:serviceApiId", wrapper.DeleteApfIdServiceApisServiceApiId)
	router.GET(baseURL+"/:apfId/service-apis/:serviceApiId", wrapper.GetApfIdServiceApisServiceApiId)
	router.PUT(baseURL+"/:apfId/service-apis/:serviceApiId", wrapper.PutApfIdServiceApisServiceApiId)

}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+xab1PbOtb/Kho9zwuYMQ4J0DvNuzSE3ly6JIvNndm5dBjFPsFqHckryYEsk+/St/s1",
	"+GQ7kmzHSUQI0G27A29aY8lHR+fP7/yOlDsc8UnGGTAlcfsOyyiBCTGPHRgPBR/TFPRfmeAZCEXBjBEY",
	"92P9EIOMBM0U5Qy3cT8GpuiYgkB8jFQCqDPsI7jNuKTsGo1zFpmZHlazDHAbSyUou8ZzD8dEkRMuJkRp",
	"sf8vYIzb+P8aC+0ahWqN48VM/R2fEMrOyATW1Tk2Y0hxdJPQKDHKjCDl7FoixV1aUKZAjEkExwtB0rHP",
	"chqKQRGaSuxhqmAiH9O975Cv151Q1rffNyutiBBkpgczwRWPePqY8GE5b+5hCVEuqJr9DVTCY8cWgmIC",
	"mtgZSOZZxoWCGI1m1nW9k223FSyt9uiGpiCk27DaQ8Xotmv/WUzfvOjcwwL+mVMBMW7/VcRvTZPP1Qd8",
	"9AUiE1pdPpnkjEZEKxea0TtM2Gwwxu2/7jCwfKJlnff+ftELwqvzXjAcnAU97OHg4kPQPe9/6F2dDcL+",
	"yT9q4qtYW916mFCJ7CjKBJ/SGCQac3FDRLyn900UHdFUu+yGqgSNc5ULQHCrgJk96DjXftN6gTBKo1Gu",
	"EJWIcYVyCbGeAiziMaCIMwVMoRjGlEGMdJ4kgDIBUr8uDGPTmEqdOv6lI3E/eyvbGHIp6SgFNCVpDhIR",
	"AWgPrdqojcJE61AzsNazAA29BtLuAqn2BMiMM6mlrJp1CykyH2ntRrDHuKLj2aUJlG4uFZ8MssJM6/im",
	"ZZYe3xR86yEy93CUSzXI3JBEjT8kKEQkulvMnKOMCFWqfnHe16GQR8bFYy4QQZHRGfFSaRMFPFdIgOS5",
	"iAARKXlE7SCRdc/KfBSlJJdw/+3QP9SrHHwcDu+/hcH9t9Z7/2i/6Tsxua76WrzCrY6e6lWp+6qeLsHV",
	"oAuYKhz6PQyHFTxpI5QFpdyxjwYsnSGSZSmNiA66mwTKOLZYqHe/KGSIslg7C6QR7m+LMYtIeRLKVFG0",
	"FBMuqDleqn7rGPNHMDh79SCijdBGf5ApCcxcNDD2Q2dcGUVtbjtL7FqC02x62IljUfN8GLTeN1utK53T",
	"nGmP+DMySd11vPxcc4Zs+u5lot6VonTgP1PMUH/6fQp/RYI8RBVS5KvxaAQxsAgQn4LNRLkqqAi4eDnn",
	"vCJ1dWBmENExjRYr+P8VhjF3ZNgS2K8n2MdeiD08HATmvwvzbyfs/o49fNz71At7rz77PvbCtoXkj72w",
	"8DnaQ9pkxXv9WBu4qN5f1F9rq5YD+nkxZA1djNk/ikGb2cMaD173oP7qqnnVxJ59bL16j5UWKSxaSm/6",
	"zXKwtTLUKgydj1IqE4g7GR0SlTj4UTTuu8Clg1IqDY3pdk8QrdpBqSuzgAI3xJRGtpJTiUgqgMQzlJWL",
	"LmHCGnV4YtqfF1Thf5PilYwOYht+pE72fhbBqzOw10TuNLezqrn9XoYaYnrYYZhcUNdXKVF0agPCYWFT",
	"g2vxRDIaFGW0XPBC0CERalN8fYdoWeG2S7bw6lRXb9PFcVdKuBPEh8GprrynfezhQeci/P3Vg/gwOG2j",
	"Fc6GmmjnwpyohZ+CvWFwumsdbDtdo5F2KAoDdHDgN1stLee0vy6nVcoZnva3kGE8si7lAO2EnwJr20En",
	"VwlS/CuwxwTaWhPYatAZ9jfydVKluavq9E604wsQGJs+inLmFcd+lEVprmPC+Pg249qfOseKwzu0A/61",
	"X6HK7tbIUTshfQw6SEZdB6amBi4OTYmU9JotmHi3M+yfoIjrClGcnZaxWpXLej31UZCQNDVRO1qEZBGh",
	"C5JWnK2gseCTCnEKifWD2nIxhx7lUpuXKY5uqnU2bOghFQiLlyRr9vlkwZRN+VcQaCemMtIdzEy/3nUW",
	"RZJRN8BrQRrbHZD8WH3/LtVaQ3+eZSdAlFzpEo9+a27VJVb1VwvJBUhDZiLnYb7LpItY/a58wiUry0c1",
	"+rnx3HuVrpo2uISVLlFwzcXMySZlQgRoctFnY/5oD1qfXGCMEbJm1O/mnNVj6yI0neXVpd066yUZ1aA1",
	"PeYTB5J+Ktm78X1RTAWylyxycZOyxuMXa+pJI0DGss/n8h6mstqR6xBD6XUusRI5XOIa9VMJUWvqERY3",
	"uFh7HRWhgSLCFjqXuJFuskV9xz4aqATEDZVgMMEoNiaphEtcS5MR5ykQtubU+kZdji0vONZrYkZrY+tY",
	"NSFfuKj4CGUGk2ytmzZ3XTlnm5WH6Xt3pUGRGw+ht66jq8fxj4UG3GbUJvQzsuyYKAjpBOqEXj7M5l0X",
	"Y8P+1lur+s+nXU8tPOuKCJJtvH0tbkJqzYSjrjrxu0RNN1kJLMUuasBMPxNmUm9K45ykD3ASRythfKhA",
	"MJIe88hh/aV62Gq17r/92XznH/j799+sj822TgSZwA0XX00DadjlGRcqGfGcGYYnTTuS4jZOlMrajcbN",
	"zY1/cJ1lPhfXjbHKGrqXkg0iooROodF6fyVBUJANu2zD3gnb0rCeYHrVmmlrm5b+Jbv/N2rtt/Y9q9hA",
	"XBNG/2VcQ1KkGzYGQqKdznn/g4c6YT/wULcbdDzUC4O+h8Lg2PwXdvQ/3V3/knXSFAl6nSip8w3EFOKi",
	"taBKo6Qt2VdFPbwqqPWVLbDltWobN/2mv1906oxkVNvb3/f3sYczohLjjsadCbJ5o9jUHsmoGbgG5UoW",
	"JShMAWlGuIgCYwhcOxHQUYU/gupo2UEVbNKsrJ2pQEjTEFItVmuDPWz66XYR9fVE0eDvFT9ZeCwR7ddz",
	"3XaV7NHsp7W/b0+DTFNnYdWcOGh9G1+kBdft1nD3MibcV36YoLkgLbNUG60WOztyt2bDBea4s3ju4UO7",
	"hSdcGlQWaOhvjYjmC0Q0rYiDF4g4sCIOXyDi0Ip49wIR74yI1vvni2i91yKOXuCRI+uRoxeY88iaM4Yx",
	"yVP1bDHl9yaAMy4diV9ADSKIwU2J9svpPuTyp+e76XY/8Hj2I1J9Wd/5Gt40fzzeBDXSWyvSeRSBlOM8",
	"TWfmlxS1I8hIgDl2rnidLLt9ASoXtXOvS/yJW+0vse3QEyCxbRDtk9l3OclBKjlTtrtYVoHBTTpbU8RD",
	"JIq4iDUKFkS9arPbphc/51zNG9U2TeVqTJvOita4q1Oe+cZoWyMxb9C7DL3NF2ykaTfSfMFGmnYjzaMX",
	"iDh6KwDuAjD38FYJZLI7BeXo2S9YVlWLBzuF5dpxbEStVo+g3qVsU0nk8gfPKyhLQuZz74dy1EPHcVoC",
	"j/ZeaEJUZAhj7eijM6T9GFGJrKPiNw65CmRv+e8ggI80ftumtKP7e4X5/Kv1nG8N51vD+as1nLkDby6y",
	"mKgnoM0wf6Vo80t1vD8d7epIl5sQWu5+31DtrZd7Rb1ccdNTYp69IdlwdII9PCWCklFaXTzqmRaeC7XM",
	"DYtsNxpwSyZZCn7EJ3g1K4sPH/o5BPrNPyp/DYHCANlLGF/r/Hn+nwAAAP//YaP33qo4AAA=",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %s", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	var res = make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	pathPrefix := path.Dir(pathToFile)

	for rawPath, rawFunc := range externalRef0.PathToRawSpec(path.Join(pathPrefix, "TS29122_CommonData.yaml")) {
		if _, ok := res[rawPath]; ok {
			// it is not possible to compare functions in golang, so always overwrite the old value
		}
		res[rawPath] = rawFunc
	}
	for rawPath, rawFunc := range externalRef1.PathToRawSpec(path.Join(pathPrefix, "TS29571_CommonData.yaml")) {
		if _, ok := res[rawPath]; ok {
			// it is not possible to compare functions in golang, so always overwrite the old value
		}
		res[rawPath] = rawFunc
	}
	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	var resolvePath = PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		var pathToFile = url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
