// Package securityapi provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.9.1 DO NOT EDIT.
package securityapi

import (
	"bytes"
	"compress/gzip"
	"encoding/base64"
	"fmt"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/deepmap/oapi-codegen/pkg/runtime"
	"github.com/getkin/kin-openapi/openapi3"
	"github.com/labstack/echo/v4"
	externalRef0 "oransc.org/nonrtric/plt/capif/internal/readonly/common"
	externalRef1 "oransc.org/nonrtric/plt/capif/internal/readonly/common29571"
	externalRef2 "oransc.org/nonrtric/plt/capif/internal/readonly/publishserviceapi"
)

// ServerInterface represents all server handlers.
type ServerInterface interface {

	// (POST /securities/{securityId}/token)
	PostSecuritiesSecurityIdToken(ctx echo.Context, securityId string) error

	// (DELETE /trustedInvokers/{apiInvokerId})
	DeleteTrustedInvokersApiInvokerId(ctx echo.Context, apiInvokerId string) error

	// (GET /trustedInvokers/{apiInvokerId})
	GetTrustedInvokersApiInvokerId(ctx echo.Context, apiInvokerId string, params GetTrustedInvokersApiInvokerIdParams) error

	// (PUT /trustedInvokers/{apiInvokerId})
	PutTrustedInvokersApiInvokerId(ctx echo.Context, apiInvokerId string) error

	// (POST /trustedInvokers/{apiInvokerId}/delete)
	PostTrustedInvokersApiInvokerIdDelete(ctx echo.Context, apiInvokerId string) error

	// (POST /trustedInvokers/{apiInvokerId}/update)
	PostTrustedInvokersApiInvokerIdUpdate(ctx echo.Context, apiInvokerId string) error
}

// ServerInterfaceWrapper converts echo contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler ServerInterface
}

// PostSecuritiesSecurityIdToken converts echo context to params.
func (w *ServerInterfaceWrapper) PostSecuritiesSecurityIdToken(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "securityId" -------------
	var securityId string

	err = runtime.BindStyledParameterWithLocation("simple", false, "securityId", runtime.ParamLocationPath, ctx.Param("securityId"), &securityId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter securityId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostSecuritiesSecurityIdToken(ctx, securityId)
	return err
}

// DeleteTrustedInvokersApiInvokerId converts echo context to params.
func (w *ServerInterfaceWrapper) DeleteTrustedInvokersApiInvokerId(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "apiInvokerId" -------------
	var apiInvokerId string

	err = runtime.BindStyledParameterWithLocation("simple", false, "apiInvokerId", runtime.ParamLocationPath, ctx.Param("apiInvokerId"), &apiInvokerId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter apiInvokerId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.DeleteTrustedInvokersApiInvokerId(ctx, apiInvokerId)
	return err
}

// GetTrustedInvokersApiInvokerId converts echo context to params.
func (w *ServerInterfaceWrapper) GetTrustedInvokersApiInvokerId(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "apiInvokerId" -------------
	var apiInvokerId string

	err = runtime.BindStyledParameterWithLocation("simple", false, "apiInvokerId", runtime.ParamLocationPath, ctx.Param("apiInvokerId"), &apiInvokerId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter apiInvokerId: %s", err))
	}

	// Parameter object where we will unmarshal all parameters from the context
	var params GetTrustedInvokersApiInvokerIdParams
	// ------------- Optional query parameter "authenticationInfo" -------------

	err = runtime.BindQueryParameter("form", true, false, "authenticationInfo", ctx.QueryParams(), &params.AuthenticationInfo)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter authenticationInfo: %s", err))
	}

	// ------------- Optional query parameter "authorizationInfo" -------------

	err = runtime.BindQueryParameter("form", true, false, "authorizationInfo", ctx.QueryParams(), &params.AuthorizationInfo)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter authorizationInfo: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetTrustedInvokersApiInvokerId(ctx, apiInvokerId, params)
	return err
}

// PutTrustedInvokersApiInvokerId converts echo context to params.
func (w *ServerInterfaceWrapper) PutTrustedInvokersApiInvokerId(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "apiInvokerId" -------------
	var apiInvokerId string

	err = runtime.BindStyledParameterWithLocation("simple", false, "apiInvokerId", runtime.ParamLocationPath, ctx.Param("apiInvokerId"), &apiInvokerId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter apiInvokerId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PutTrustedInvokersApiInvokerId(ctx, apiInvokerId)
	return err
}

// PostTrustedInvokersApiInvokerIdDelete converts echo context to params.
func (w *ServerInterfaceWrapper) PostTrustedInvokersApiInvokerIdDelete(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "apiInvokerId" -------------
	var apiInvokerId string

	err = runtime.BindStyledParameterWithLocation("simple", false, "apiInvokerId", runtime.ParamLocationPath, ctx.Param("apiInvokerId"), &apiInvokerId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter apiInvokerId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostTrustedInvokersApiInvokerIdDelete(ctx, apiInvokerId)
	return err
}

// PostTrustedInvokersApiInvokerIdUpdate converts echo context to params.
func (w *ServerInterfaceWrapper) PostTrustedInvokersApiInvokerIdUpdate(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "apiInvokerId" -------------
	var apiInvokerId string

	err = runtime.BindStyledParameterWithLocation("simple", false, "apiInvokerId", runtime.ParamLocationPath, ctx.Param("apiInvokerId"), &apiInvokerId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter apiInvokerId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostTrustedInvokersApiInvokerIdUpdate(ctx, apiInvokerId)
	return err
}

// This is a simple interface which specifies echo.Route addition functions which
// are present on both echo.Echo and echo.Group, since we want to allow using
// either of them for path registration
type EchoRouter interface {
	CONNECT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	DELETE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	GET(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	HEAD(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	OPTIONS(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PATCH(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	POST(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PUT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	TRACE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
}

// RegisterHandlers adds each server route to the EchoRouter.
func RegisterHandlers(router EchoRouter, si ServerInterface) {
	RegisterHandlersWithBaseURL(router, si, "")
}

// Registers handlers, and prepends BaseURL to the paths, so that the paths
// can be served under a prefix.
func RegisterHandlersWithBaseURL(router EchoRouter, si ServerInterface, baseURL string) {

	wrapper := ServerInterfaceWrapper{
		Handler: si,
	}

	router.POST(baseURL+"/securities/:securityId/token", wrapper.PostSecuritiesSecurityIdToken)
	router.DELETE(baseURL+"/trustedInvokers/:apiInvokerId", wrapper.DeleteTrustedInvokersApiInvokerId)
	router.GET(baseURL+"/trustedInvokers/:apiInvokerId", wrapper.GetTrustedInvokersApiInvokerId)
	router.PUT(baseURL+"/trustedInvokers/:apiInvokerId", wrapper.PutTrustedInvokersApiInvokerId)
	router.POST(baseURL+"/trustedInvokers/:apiInvokerId/delete", wrapper.PostTrustedInvokersApiInvokerIdDelete)
	router.POST(baseURL+"/trustedInvokers/:apiInvokerId/update", wrapper.PostTrustedInvokersApiInvokerIdUpdate)

}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+xa3Y7aSBZ+lZJnpUkktw0knSjcEZpEjGY6qCGTlSYtVNjHUNN2lXOqDM22eJfc7mv0",
	"k62qyoCxTf8xvbszw81MY586dX6/8xPfOIFIUsGBK+m0bxwZzCCh5s9OEICUI3EFvIeon6QoUkDFwLwH",
	"RGEeA88Sp/2bw/icxiwcI3zLQCrH3TwJYga8+GCK1PzOOM3UTCD7FxSoMi6zNBWoIKccq2UKheMyECk4",
	"l65jnrcdqZDxqbNyrVDjEGSALFVMcC3gHqoMWc3bletoBRhCqJWyWm6vEpPfIVCaScE+F/BNc4oEJlQ5",
	"bef6ZLFYnOifJxnGwAMRQui4JQNafccsrJUxfyshQFC1FAXTFLyQnwsQQuCK0VjWGsqa8F71d8y/Ffiy",
	"pL9Mq/FBzfux0gT6945TnJ++DElXJCkNFBkCMhrrGCAIKYIErqimIyIimlCyKYeQ/DT8dE6sA8iLwvXd",
	"mLJEvnTq4uE6ZQhyzIwI/0CInLYzGrbeNVutcVckieBnVFFvSZP4B3+bC36eCP5ZhkaUIQR3mc11jJ4V",
	"b7wHioA1HijZecdYO8x2dKiLwy7NpLmT8uWnyGn/tr3906+9i5/7v/RH48/Dzsee4zqfz3v/HPS6o97Z",
	"+KLXGX46rwuOsq9GMyaJfUtSFHMWgiSRwAXF8ETbjCo2YTFTS7JgakaiTGUIBK4VcMkEl0QJomZAtFxg",
	"7UkmmSJMEi4UySSEmsQmCgkEV8AVCSFi2u2Mm8N5YJA5oMxjQ2nBOoO+95VXnX/pltQYCCnZJAYyp3EG",
	"klAEckJKNmqT0QwIwlwEmxDUt69xaudhZ9AnjM/FFaDWJcxgramYA8YsYVo5OoX1AQk4Z4E9eEIqzvgD",
	"Ls84XKcQKJNLVAqubbNynSEEGTK17HOLUjk0Cg55zBSjkXEFGNEAzkBRphFEB8VOvELU1zBwWQY1+6KS",
	"7n0DRhEDLIoP16mQOqqijAeGsiaFtfL6sDWJlr/KvrNDQxBiqkzkbJXdw3lj1v2Mt5Z/IN+K+Xahp6Wh",
	"pzPofxgPsknM5Gw8tGEx1qG8F4n6W65bCVfa/hCtvfsLqJkIZVWPNQFJLIXOpggQISSTZSWcIoGFZ/m1",
	"ni7ACpI/SJ1dkbUiCeN9y7+5MSpFpEsDvBCXTjyLFCVYrrNtHQavac6FDvJgk14Pyo2hRVZmU2Sp/zbG",
	"733waqM2Zf06F1dTrIA2Rd9VON5peH2dDYvHyF4IJirz8p0HmvESCQTCnWkfrMta7uRa99naVymmRZE3",
	"BluzrPefsdTajVXX8YJjz0Aqxjc+fkJT8RmZk8sMUo1AqnLglLNXmcKCGWgrFq2rBMnZ7DOuJpHAQ0KJ",
	"0mRFVQiVxTLLOJHZJIi1nchb741H8psjGksgAolImNIIKNQMcMEkFEJ0IkQMlNts3VYbrU4ZN+7MxWKJ",
	"stHJEt3P1KHCek74AFT3HGVsOn3bfJBDhhU+K9dZwESK4Mq4pit4xKZPdPeXKqNyyO4YzN0bbtXYXZkm",
	"VwFyGp+JoAYXXn0cDG6/j4a331vvvFardfv91+ap99Zr3H63wpt4+oA0gYXAKwP++gw5F6hmE5HxUFPo",
	"BMowdtrOTKm07fuLxcJ7NU1TT+DUj1TqD1MIpE8xmLE5+K13YwnIQPr2Wt9WxtoiO+ibW23wyk2popxO",
	"IQGuvK/89t+k1Wg1XCvaJ5xSnldlGpMBRcUBJXnRuei/d0ln1B+6pNsddlzSGw37LhkNz8z/Rh39n+5L",
	"7yvvxDFBNp0pSXRniXMI8z6SqVib2JaTdVSOLYrm3afTdppew3ullRIpcJoybWqv4TX0nEfVzHjCz5XR",
	"ZrjZ+Dhc+ZupKBXSTHcabGwfEtpWVQ03RzeJEY7y+SCl2l0KUJre7a5CQHVah2zOwozGRegw87TTNsLq",
	"kKOJAeDNXU4xQjX0uPl2oG5qvNyg2XsRGvzMu3hT99I0zoPZrx+NN5uH+zCiNHSvdvNIS2keyFRwadGg",
	"1WjcIc7v0uLt42+Xqb29hNSZIYmymFhiYqjJRb4TWbnO6+cRqIdYJ1APUeB6hKoXyZzyFWZSQZgXTunf",
	"FKvoyiZtDAqqwXpmno92z3d2a/DzBWyp2D8yZHcC5XUVms4F6ebj6IuCb40pCrMYXDMN0lNdPjfHXxa8",
	"/YiqsRHK12cNi+YBLJqWxasDWLyyLF4fwOK1YdF693QWrXeaxekB5jy15jw9wBan1hYhRDSL1ZPZrM+b",
	"zJtCTQH4COpPl1CVvdGXGXAibQf5oz79o0uYMsIEVIG8t2Nd7z4Ko31h9K5ZhDywYTVaf8sAlwW1q2uG",
	"GmU3Pe4zarvdNzyrsrubjzt1vXzGmloevWpq2MjMsnlXWLODKdomD10yoVIbwta99YQUoUj2L5+8I16X",
	"8Lrx5gAWbwyL5gFSNI9VY2/VSDPDKKBxPKHB1X1Lips8BbyJCJc/+HsoV8WJ5GH9/GOTvWZP9qAm/p7e",
	"TG57s6JuxxasnNLNAxRpWkWaByjStIo0Tw9gcXpEhXpUMIlUWiRk6s85mD0H9tzbaAQIVAGh227D3Hyt",
	"zHqK8pLS92FW878pe2E6tWqEuvmbAQ2Nb2+cn8W+9bJGUcq47VA/X/TX/RSHRbxccyMIUmQYgEtoEAgM",
	"za7f/munVJgFKkNokxuasgsh1MoPaMqik7Ul/XnzvhXDY2Jk9ZfC9f8TUD68VTvi+rPg+r3rOX+7m9u/",
	"UL6jENgV3t+sHOxrRXeVvgAt9MM+w9BVojPoS895UkNbgHA0t4bHkfTYvx5xroBzWRrSA3Dusz1+bHt3",
	"9LVWyT8ZKTW+L8CbegThhMNUKFahy78nevkQyGv8j/phGzRHMD2C6d9qGeA65quGHOLstxt3jGeO68wp",
	"MjqJ86/VLKVtU3KxzLcfsu37cE2TNAYvEIlTzrz8YOnbouKHRacaV82HHKMhsZ+HeFrmy9V/AgAA//9y",
	"Bb8TkDAAAA==",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %s", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	var res = make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	pathPrefix := path.Dir(pathToFile)

	for rawPath, rawFunc := range externalRef0.PathToRawSpec(path.Join(pathPrefix, "TS29122_CommonData.yaml")) {
		if _, ok := res[rawPath]; ok {
			// it is not possible to compare functions in golang, so always overwrite the old value
		}
		res[rawPath] = rawFunc
	}
	for rawPath, rawFunc := range externalRef2.PathToRawSpec(path.Join(pathPrefix, "TS29222_CAPIF_Publish_Service_API.yaml")) {
		if _, ok := res[rawPath]; ok {
			// it is not possible to compare functions in golang, so always overwrite the old value
		}
		res[rawPath] = rawFunc
	}
	for rawPath, rawFunc := range externalRef1.PathToRawSpec(path.Join(pathPrefix, "TS29571_CommonData.yaml")) {
		if _, ok := res[rawPath]; ok {
			// it is not possible to compare functions in golang, so always overwrite the old value
		}
		res[rawPath] = rawFunc
	}
	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	var resolvePath = PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		var pathToFile = url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
