#  ============LICENSE_START===============================================
#  Copyright (C) 2021 Nordix Foundation. All rights reserved.
#  ========================================================================
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#  ============LICENSE_END=================================================
#


NEXUS_PROXY_REPO=nexus3.onap.org:10001/

CON_APP_NAME="con-w-consumer"
CON_IMAGE_NAME="con-w-consumer"

CON_INT_PORT=9932      #Update nginx.conf if port is changed
CON_EXT_PORT=9932
CON_INT_SEC_PORT=9933  #Update nginx.conf if port is changed
CON_EXT_SEC_PORT=9933

if [ "$1" == "local" ]; then
    DOCKER_NETWORK_FLAG=""
    pms_name=localhost
    ecs_name=localhost
else
    DOCKER_NETWORK_FLAG="--network nonrtric-docker-net"
    pms_name=policymanagementservice
    ecs_name=enrichmentservice
fi

if [ "$1" == "local" ]; then
    PORT=$CON_INT_PORT
elif [ "$1" == "local-secure" ]; then
    PORT=$CON_INT_SEC_PORT
else
    PORT=$CON_INT_PORT
fi

export OWN_HOST=http://$CON_APP_NAME:$CON_INT_PORT
export CONSUMER_NAME=con-w
export PMS_BASE=http://$pms_name:8081
export ECS_BASE=http://$ecs_name:8083